		opt	t+,m+,c+
		bra.s	EntryPoint
;*********************************************************************
;*
;*	SInDiCo		Copyright (C) 1990,91  Martin Rex
;*
;*	Size INdependent DIsk COpier
;*	Copy and Speed up your Amiga floppies
;*	(and SMALL partitions of your Ram or Hard Disks)
;*
;*      Version 1.31   27-Apr-91		(started 22-Jan-1990)
;*
;*	SInDiCo was written with DevPac Assembler 2.11D from HiSoft
;*
;*	--------------------------------------------------------------------
;*	This program is free software; you can redistribute it and/or modify
;*	it under the terms of the GNU General Public License as published by
;*	the Free Software Foundation; either version 1, or (at your option)
;*	any later version.
;*
;*	This program is distributed in the hope that it will be useful,
;*	but WITHOUT ANY WARRANTY; without even the implied warranty of
;*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;*	GNU General Public License for more details.
;*
;*	You should have received a copy of the GNU General Public License
;*	along with this program; if not, write to the Free Software
;*	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;*	--------------------------------------------------------------------
;*
;*  Changes:
;*  v1.31: 27-Apr-81  -- first public release
;*	When TrackSalve is detected in Memory, Sindico tries to read
;*	every sector of a bad track on a floppy disk.
;*	Without TrackSalve, the rest of a bad track will be skipped.
;*
;*  v1.30: 13-Apr-91
;*	Accepts KS 2.0 disks as well (KS 2.0 has apparently FHEADER ID removed)
;*	Stops drive motor after `write-protect'-Errors.
;*	Lists Real Block number of corrupted sectors.
;*
;*  v1.29: 09-Jan-91
;*	Write-Verify for 3.5"-disks may be disabled, if TrackSalve is installed
;*
;*  v1.28: 26-May-90
;*	FS-identification was changed to 'COPY' when writing was aborted
;*
;* -------------------------------------------------------------------
;* Author:	Martin Rex
;*		Berlinerstr.5
;*		6902 Sandhausen
;*		Federal Republic of Germany
;*
;*		Home Phone:  0049 +6224 +4024
;*
;*		E-MAIL:  X910@DMAFHT1.bitnet   !valid until 30-Sep-91!
;*
;*********************************************************************

		NOLIST

; ------------------

dl_Root			equ	$22
rn_Info			equ	$18
di_DevInfo		equ	4
dn_Startup		equ	$1c
dl_Name			equ	$28
dl_Type			equ	4

fssm_Unit		equ	0
fssm_Environ		equ	8
fssm_Device		equ	4

de_TableSize		equ	0
de_SizeBlock		equ	4
de_SecOrg		equ	8
de_Surfaces		equ	12
de_SectorPerBlock	equ	16
de_BlocksPerTrack	equ	20
de_Reserved		equ	24
de_PreAlloc		equ	28
de_Interleave		equ	32
de_LowCyl		equ	36
de_HighCyl		equ	40
de_NumBuffers		equ	44
de_BufMemType		equ	48
de_MaxTransfer		equ	52
de_Mask			equ	56
de_BootPri		equ	60
de_DosType		equ	64
DE_DOSTYPE		equ	16

DLT_DEVICE		equ	0
ACTION_INHIBIT		equ	$1f

; ----------
LIBRARY_VERSION		equ	$21
MEMF_CHIP		equ	2
MEMF_PUBLIC		equ	1
MEMF_CLEAR		equ	$10000
SIGBREAKB_CTRL_C	equ	12
SIGBREAKF_CTRL_C	equ	$1000
LF			equ	10
IOTD_SIZE		equ	$38
MP_SIZE			equ	$22


ThisTask		equ	$114
mn_ReplyPort		equ	14
mp_SigTask		equ	16
tc_SigRecvd		equ	$1a
ln_Name			equ	$0a
iotd_Count		equ	$30
iotd_SecLabel		equ	$34
io_Data			equ	$28
io_Command		equ	$1c
io_Actual		equ	$20
io_Length		equ	$24
io_Error		equ	$1f
io_Offset		equ	$2c

CMD_READ	equ	2
CMD_WRITE	equ	3
CMD_CLEAR	equ	5
CMD_UPDATE	equ	4
TD_MOTOR	equ	9
TD_FORMAT	equ	11
ETD_READ	equ	$8002
TDERR_BadSecHdr	equ	$1b
TDERR_WriteProt	equ	$1c

sc_BitMap	equ	$b8
sc_Width	equ	12
sc_Height	equ	14
bm_Depth	equ	5
bm_Planes	equ	8

; ----------------------  Library Calls  -----------------------
Sys_AllocMem		equ	-198
Sys_FreeMem		equ	-210
Sys_SetSignal		equ	-306
Sys_AddPort		equ	-354
Sys_RemPort		equ	-360
Sys_PutMsg		equ	-366
Sys_GetMsg		equ	-372
Sys_WaitPort		equ	-384
Sys_CloseLibrary	equ	-414
Sys_OpenDevice		equ	-444
Sys_CloseDevice		equ	-450
Sys_DoIO		equ	-456
Sys_RawDoFmt		equ	-522
Sys_OpenLibrary		equ	-552
Sys_FindSemaphore	equ	-594

Dos_Read		equ	-42
Dos_Write		equ	-48
Dos_Input		equ	-54
Dos_Output		equ	-60
Dos_DeviceProc		equ	-174
Dos_IsInteractive	equ	-216

Int_OpenWorkBench	equ	-210
Int_RemakeDisplay	equ	-384

; ----------------------  MACRO's  -----------------------------
sp_SysBase	equ	4

byte		equ	1
word		equ	2
long		equ	4
;--------	-	-	-	----------
CCALL_LIB	MACRO
	IFC 'Sys','\1'
		move.l	(sp_SysBase).w,a6
	ELSEIF
		move.l	sp_\1Base(a5),a6
	ENDC
		jsr	\1_\2(a6)
	ENDM
;--------	-	-	-	----------
CALL_LIB	MACRO
		CCALL_LIB \1,\2
		tst.l	d0
	ENDM
;--------	-	-	-	----------
OPENLIB		MACRO
		moveq	#LIBRARY_VERSION,d0
		lea	cS_\1libname(pc),a1
		CCALL_LIB Sys,OpenLibrary
		move.l	d0,sp_\1Base(a5)
	ENDM
;--------	-	-	-	----------
CLOSELIB	MACRO
		move.l	sp_\1Base(a5),d0
		beq.s	.closed\@
		move.l	d0,a1
		CCALL_LIB Sys,CloseLibrary
.closed\@:	clr.l	sp_\1Base(a5)
		ENDM
;--------	-	-	-	----------
CLOSEDEVICE	MACRO
		lea	\1(a5),a1
		tst.l	IO_DEVICE(a1)
		beq.s	.closed\@
		CCALL_LIB Sys,CloseDevice
.closed\@	lea	\1(a5),a1
		clr.l	IO_DEVICE(a1)
		ENDM
;--------	-	-	-	----------
CPFARG	MACRO
	IFEQ NARG-2
	  IFC '\2','b'
		move.b	\1,d0
		ext.w	d0
		move.w	d0,-(a7)
clstck	SET	clstck+2
	  ENDC
	  IFC '\2','w'
		move.w	\1,-(a7)
clstck	SET	clstck+2
	  ENDC
	  IFC '\2','l'
		move.l	\1,-(a7)
clstck	SET	clstck+4
	  ENDC
	ELSEIF
		pea	\1
clstck	SET	clstck+4
	ENDC
	ENDM

CPRINTF	MACRO
clstck	SET	0
	IFNE (NARG>6)
	CPFARG	\7
	ENDC
	IFNE (NARG>5)
	CPFARG	\6
	ENDC
	IFNE (NARG>4)
	CPFARG	\5
	ENDC
	IFNE (NARG>3)
	CPFARG	\4
	ENDC
	IFNE (NARG>2)
	CPFARG	\3
	ENDC
	IFNE (NARG>1)
	CPFARG	\2
	ENDC
	IFNE (NARG>0)
		pea	.cS_\@(pc)
		bsr	_Cprintf
	IFNE (clstck>4)
		lea	clstck+4(a7),a7
	ELSEIF
		addq.l	#clstck+4,a7
	ENDC
		bra.s	.weiter\@
.cS_\@	dc.b	\1,0
	even
.weiter\@:
	ENDC
	ENDM
; ---------------------------  Cprintf  -----------------------------
savreg		reg	d1-d7/a1-a6

__PutCh:	move.b	d0,(a3)+
		addq.w	#1,d7
		rts
_Cprintf:				; len = Cprintf(format,args);
		move.l	a7,a0
		movem.l	savreg,-(sp)
		lea	8(a0),a1		;args
		move.l	4(a0),a0		;format
		lea	__PutCh(pc),a2
		move.l	acp_CpBuf(a5),a3
		moveq	#0,d7
		CCALL_LIB Sys,RawDoFmt

		move.l	a3,d2			; d2 = buffer
		move.l	d7,d3			; d3 = length
		move.l	bp_StdOut(a5),d1	; d1 = file
		CCALL_LIB Dos,Write		; Write(StdOut,buffer,len)
		movem.l	(sp)+,savreg		; (Status in d0)

		rts
;--------	-	-	-	----------
PUTS	MACRO
		lea	cS_\1(pc),a0
		bsr	Puts
	ENDM

Puts:		movem.l	d0-d3/a1,-(a7)
		move.l	a0,d2
		move.w	#$0fff,d3
.loop:		tst.b	(a0)+
		beq.s	.putt
		dbf	d3,.loop
.putt:		eor.w	#$0fff,d3
		and.w	#$0fff,d3
		ext.l	d3
		move.l	bp_StdOut(a5),d1
		CCALL_LIB Dos,Write
		movem.l	(a7)+,d0-d3/a1
		rts

; # # # # # # # # # # # # #  defines  # # # # # # # # # # # # # # #

SIZE			equ	128		; Size of a Sector (must be 512)
MIN_BLOCKS		equ	20		; Minimum Block#
MAX_BLOCKS		equ	4064		; Maximum Block#
NAMEBUF			equ	40
CPBUF			equ	200		; Buffer for Cprintf-strings
TBSIZE			equ	SIZE*4*11	; Default Track-Buffer size
MAX_DIRS		equ	80		; maximum nesting of Directories

; - - - - - - - - - - - - - - - - - - -
; here are some constant definitions, where
; FH = FileHeader ; FL = FileList ; UD = UserDirectory
; RT = RootBlock ; DB = DataBlock ; BM = BitMapBLock
; and ALL_ common to all Blocks
TYPE		equ	0*4	; RT UD FH FL DB
OWNKEY		equ	1*4	; RT UD FH FL     (DB in KS 2.0+ ????)
FHEADER		equ	1*4	;             DB  (^^^^^^^^^^^^^ ????)
COUNT		equ	2*4	;       FH FL
SEQUENCE	equ	2*4	;             DB
HTSIZE		equ	3*4	; RT
DATASIZE	equ	3*4	;       FH FL DB
FIRST		equ	4*4	;       FH FL
NEXT		equ	4*4	;             DB
CHECKSUM	equ	5*4	; RT UD FH FL DB
HASHTABLE	equ	6*4	; RT UD
BLOCKN0		equ (SIZE-51)*4 ; RT UD FH FL
BMFLAG		equ (SIZE-50)*4 ; RT
BMBLOCK		equ (SIZE-49)*4 ; RT
BYTESIZE	equ (SIZE-47)*4 ;       FH
COMMENT		equ (SIZE-46)*4 ;    UD FH
NAME		equ (SIZE-20)*4 ; RT UD FH
CREATICKS	equ (SIZE-5)*4	; RT
HASHCHAIN	equ (SIZE-4)*4	;    UD FH
PARENT		equ (SIZE-3)*4	;    UD FH (FL)
EXTENSION	equ (SIZE-2)*4	;       FH FL
STYPE		equ (SIZE-1)*4	; RT UD FH FL

; bBbBbBbBbBbBbBbBbBbBbBb  Begin  bBbBbBbBbBbBbBbBbBbBbBb
EntryPoint:
		move.l	d0,d3
		move.l	a0,d4
		move.l	#(VariLen+7)&$fff8,d0
		move.l	#MEMF_CLEAR+MEMF_PUBLIC,d1
		CALL_LIB Sys,AllocMem
		move.l	d0,a5
		bne.s	.VarsOK
		moveq	#20,d0
		rts

.VarsOK:	move.w	d3,s_dosccnt(a5)	; save CommandLine
		move.l	d4,acp_doscom(a5)	; characteristics

Go:		move.l	a7,l_panic(a5)		; save Stack-value
		lea	0-CPBUF(a7),a7		; Install CpBuf on Stack
		move.l	a7,acp_CpBuf(a5)

		moveq	#0,d7			; clear Flags and Errors
		bset	#15,d7			; allow SETNEG macro
SETZERO	MACRO
		tst.b	d7			; low 8 bits of d7 are always cleared
	ENDM
SETNEG	MACRO
		tst.w	d7			; bit 15 of d7 is always set
	ENDM
SETNOTEQ	MACRO
		tst.l	d7			; bit 31 of d7 is always cleared
	ENDM

		move.w	#16,l_maxleni(a5)	; default for maxleni
		move.w	#3,l_maxlena(a5)	; default for maxlena
		move.w	#SIZE*4,s_seclen(a5)
		move.w	#8,s_Reserve(a5)	; default Directory reservation

		bsr	ClearBreak
		OPENLIB Dos			; Open 'dos.library'
		beq.s	EarlyEnd
		OPENLIB Int			; Open 'intuition.library'
		bne.s	notEarlyEnd

EarlyEnd:	moveq	#20,d7
		bra	NoLibs

notEarlyEnd:	CCALL_LIB Dos,Output
		move.l	d0,bp_StdOut(a5)	; StdOut = OutPut()
		beq.s	EarlyEnd
		CCALL_LIB Dos,Input
		move.l	d0,bp_StdIn(a5)		; StdIn = Input()
		beq.s	EarlyEnd
		move.l	d0,d1
		CALL_LIB Dos,IsInteractive	; A MUST for our Operation
		beq	EarlyEnd

		move.l	(4).w,a6
		move.l	ThisTask(a6),a1
		move.l	a1,sp_MyTask(a5)

		PUTS Titel

		lea	ReplyPort(a5),a1		; Install our MsgPort
		move.l	sp_MyTask(a5),mp_SigTask(a1)
		CCALL_LIB Sys,AddPort
		bset.b	#xPORTADDED,c_flags(a5)		; Port is public

		bsr	GetFileName
		bne	ShowUsage
		move.l	d0,acp_InName(a5)
		bsr	GetFileName
		beq.s	.InputOK
		btst.l	#TESTONLY,d7
		bne.s	.tstonly
		bra	TooFewInput
.InputOK:	move.l	d0,acp_OutName(a5)
		bsr	GetFileName
		beq	TooManyInput
		btst.l	#TESTONLY,d7
		bne	TooManyInput

.tstonly:	move.l	acp_InName(a5),d0
		lea	(a5),a4			; set pointer for InDevice
		bsr	SetUpDevice
		bpl.s	SourceFound

BadSource:	lea	cS_Source(pc),a0
		bra.s	BadDevice
BadDestin:	lea	cS_Destin(pc),a0
BadDevice:	CPRINTF <" ! Sorry, '%s' is not a valid %s Device",10>,
&			<acp_InName(a4),l>,<a0,l>
		bra	FailExit

SourceFound:	tst.w	s_InTDflag(a5)
		beq.s	.nostrd
		bset.l	#SOURCETD,d7

.nostrd:	btst.l	#TESTONLY,d7
		beq.s	.getdest
		bset.l	#ONEDRIVE,d7			; fool InsertDestin
		bra	.tstonl2
.getdest:	move.l	acp_OutName(a5),d0
		lea	acp_OutName-acp_InName(a5),a4	; set pointer for OutDevice
		bsr	SetUpDevice
		bmi.s	BadDestin

		btst.l	#MIRROR,d7
		beq.s	.nom1
		btst.l	#ECONOMY,d7
		bne	BadOptME
		bra.s	.cmpsize
.nom1:		btst.l	#KEEPOLD,d7
		beq.s	.nomirror
.cmpsize:	move.w	s_InBlocks(a5),d0
		cmp.w	s_OutBlocks(a5),d0
		bne	DiffSize

.nomirror:	tst.w	s_OutTDflag(a5)
		beq.s	.dtrd
		bset.l	#DESTINTD,d7
		btst.l	#NOVERIFY,d7
		beq.s	.nodtrd
		lea	cS_TSsemname(pc),a1	; We're looking for TrackSalve
		CALL_LIB Sys,FindSemaphore	; TrackSalve v1.3 or higher
		beq.s	.nodtrd			; TrackSalve not there
		move.l	d0,a0
		cmp.l	#1000,(a0)		; Check Version number of TS
		bcs.s	.nodtrd
		PUTS	TSfound
		bset.b	#xTRACKSALVE,c_flags(a5)
.dtrd:		bset.l	#NOVERIFY,d7

.nodtrd:	move.l	acp_OutDevice(a5),a1
		cmp.l	acp_InDevice(a5),a1
		bne.s	.onedrive
		move.l	l_OutUnit(a5),d0
		cmp.l	l_InUnit(a5),d0
		bne.s	.onedrive
		bset.l	#ONEDRIVE,d7

.onedrive:	move.l	l_OutFS(a5),d0
		cmp.l	l_InFS(a5),d0
		bne	OtherFS

.tstonl2:	bset.l	#FFS,d7
		cmp.b	#1,d0		; is it FastFilesystem ?
		beq.s	.FFS
		sub.w	#6*4,s_seclen(a5)
		bclr.l	#FFS,d7
.FFS:		move.w	l_maxleni(a5),d0
		ext.l	d0
		mulu	s_seclen(a5),d0			; adjust maxleni for bytesize compare
		move.l	d0,l_maxleni(a5)
		move.w	l_maxlena(a5),d0
		ext.l	d0
		mulu	s_seclen(a5),d0			; adjust maxlena for bytesize compare
		move.l	d0,l_maxlena(a5)

; mMmMmMmMmMmMmMmMmMmM  Main Loop mMmMmMmMmMmMmMmMmMmMm
;
; ****  all Register may be changed in the Subprograms that are
; ****  called from the Main Program
;
MainLoop:	bset.l	#READING,d7		; for Errors in BlockIO
		bsr	AllocKeyTab
		beq	MemInSuffi
		move.w	s_TableSize(a5),d0
		ext.l	d0
		move.l	#TBSIZE,d1
		add.l	d0,d0
		add.l	#MAX_DIRS*8,d0
		cmp.l	d1,d0
		bhi.s	.more
		move.l	d1,d0
.more:		addq.l	#7,d0
		and.l	#$fffffff8,d0
		move.l	d0,l_TBlen(a5)
		move.l	#MEMF_CHIP+MEMF_CLEAR,d1
		CCALL_LIB Sys,AllocMem
		move.l	d0,acp_TBptr(a5)
		beq	MemInSuffi
		btst.l	#TESTONLY,d7
		bne.s	.notnecces
		bset.b	#xINHIBIT,c_flags(a5)	; flag out INHIBIT
		moveq	#-1,d0			; action Inhibit
		move.l	sp_InProc(a5),a0	; for InputDevice
		bsr	SendInhibit
		btst.l	#ONEDRIVE,d7
		bne.s	.notnecces
		moveq	#-1,d0			; action Inhibit
		move.l	sp_OutProc(a5),a0	; for OutputDevice
		bsr	SendInhibit

.notnecces:	move.l	l_InBlocks(a5),d3		; use all blocks ( = d3)
		lea	BitMap(a5),a0
		move.l	a0,acp_BitMap(a5)
		bsr	ClearSector
		btst.l	#ECONOMY,d7
		beq	.allblocks
; trying to get number of blocks for memory allocation
		btst.l	#UNDELETE,d7
		bne	BadOptUE
		bsr	InsertSource
		lea	(a5),a4			; Pointer on In-Table
		bsr	OpenDevice
		moveq	#0,d2			; block #0
		moveq	#CMD_READ,d1
		bsr	OneBlockIO
		move.l	(a0),d0
		cmp.l	l_InFS(a5),d0
		bne	BadFormat
		move.l	l_InRoot(a5),d2		; get RootBlock #
		moveq	#CMD_READ,d1
		bsr	OneBlockIO
		bne	Abort			; we allow no Errors here
		move.l	a0,a1
		bsr	CheckSum
		bne	BadFormat
		cmp.l	#2,(a1)		; is it a header-Block ?
		bne	BadFormat
		cmp.l	#1,STYPE(a1)
		bne	BadFormat
		tst.l	BMFLAG(a1)
		beq	BmBad

		move.l	BMBLOCK(a1),d2
		bsr	TestSRCblock
		bmi	BadFormat
		moveq	#CMD_READ,d1
		bsr	OneBlockIO
		bne	Abort			; we allow no Errors here
		move.l	a0,a1
		bsr	CheckSum
		bne	BadFormat
		move.w	d2,s_bmblock(a5)
		move.l	acp_BitMap(a5),a1
		bsr	MoveData

.allblocks:	moveq	#2,d2			; block# counter in d2
		move.l	d2,d3			; block used counter in d3
		move.l	awp_KeyTable(a5),a2	; get Keytable Base Address
		addq.l	#4,a2			; skip bootblocks
.loopx1:	bsr	BitMapPTRD2
		moveq	#0,d1
		btst.b	d0,(a0)
		bne.s	.free
		move.w	d3,d1			; that will be the BlockAdr
		addq.w	#1,d3			; another used sector found
.free:		move.w	d1,(a2)+		; set Pointer for Sector
		addq.w	#1,d2
		cmp.w	s_InBlocks(a5),d2
		bcs.s	.loopx1
		bsr	CloseDevice
		bset.l	#INDREF,d7

		lsl.l	#8,d3
		add.l	d3,d3
		move.l	d3,l_Buffer(a5)
		bsr	Allocate		; missing RAM returned in d3
		bmi.s	.haveMem
		cmp.l	#30000,d2
		bhi	NeedMem
		bsr	RemBitPlane
		bne	NeedMem
		bsr	Deallocate
		bsr	Allocate
		bpl	NeedMem

.haveMem:	btst.l	#ECONOMY,d7
		bne.s	.asked
		bsr	InsertSource
.asked:		bset.l	#MAYIGNORE,d7
		bsr	ReadSource
		bclr.l	#READING,d7
		bset.l	#BMVALID,d7
		bne	ReadFail
		bclr.l	#MAYIGNORE,d7
		btst.l	#TESTONLY,d7
		beq.s	FirstWrite
		bclr.l	#MIRROR,d7
		bset.l	#KEEPOLD,d7

FirstWrite:	btst.l	#MIRROR,d7
		bne.s	TryWrite
		bsr	CheckStruct
		btst.l	#KEEPOLD,d7
		bne.s	TryWrite
		bsr	Rearrange

TryWrite:	PUTS NewLine
		tst.w	s_badblocks(a5)
		beq.s	.nobads
		CPRINTF <"  bad blocks: %d",10,10>,<s_badblocks(a5),w>
.nobads:	tst.l	l_warnings(a5)
		beq.s	.nowarn
		CPRINTF <"  warnings: %ld",10>,<l_warnings(a5),l>
.nowarn:	tst.w	s_removed(a5)
		beq.s	.noremoved
		CPRINTF <"  removed : %d File(s)",10>,<s_removed(a5),w>
.noremoved:	tst.w	s_undel(a5)
		beq.s	.norestore
		CPRINTF <"  restored: %d File(s)",10>,<s_undel(a5),w>
.norestore:	btst.l	#TESTONLY,d7
		bne	Exit
		btst.l	#ONEDRIVE,d7
		beq.s	.immed
.loop:		bsr	InsertDestin
.immed:		bsr	WriteDestin
		bpl.s	Success
		lea	cS_WriteFail(pc),a0
		bsr	Confirm
		beq.s	.loop
		bne.s	Leave

Success:	PUTS Success

Leave:		btst.l	#REARRANGED,d7
		bne	Exit
		btst.l	#ONEDRIVE,d7
		bne	Exit
		btst.l	#SOURCETD,d7
		bne.s	.change
		btst.l	#DESTINTD,d7
		beq	Exit
.change:	PUTS RemoveFirst
		bsr	InputLine
		bra	Exit

; xXxXxXxXxXxXxXxXxXxXxXx  Leaving  xXxXxXxXxXxXxXxXxXxXxXx
NeedMem:	CPRINTF <10," ! Sorry I need %ld more bytes of free RAM",10>,<d3,l>
		bra.s	FailExit
TooManyInput:	lea	cS_TooMany(pc),a1
		bra.s	Faulty
TooFewInput:	lea	cS_Specify(pc),a1
		bra.s	Faulty
DiffSize:	lea	cS_DiffSize(pc),a1
		bra.s	Faulty
DiskFull:	lea	cS_DiskFull(pc),a1
		bra.s	Faulty
DirTooDeep:	lea	cS_DirTooDeep(pc),a1
		bra.s	Faulty
ReadFail:	lea	cS_ReadFail(pc),a1
		bra.s	Faulty
BadOption:	lea	cS_BadOption(pc),a1
		bra.s	Faulty
MemInSuffi:	lea	cS_MemInSuffi(pc),a1
		bra.s	Faulty
BadFormat:	lea	cS_BadFormat(pc),a1
		bra.s	Faulty
OtherFS:	lea	cS_OtherFS(pc),a1
		bra.s	Faulty
BmBad:		lea	cS_BmBad(pc),a1
		bra.s	Faulty
DiffFS:		lea	cS_DiffFS(pc),a1
		bra.s	Faulty
BadOptUE:	moveq	#'u',d0
BadOptEx:	lea	cS_BadOptEx(pc),a1
		move.b	d0,cS_Option-cS_BadOptEx(a1)
		bra.s	Faulty
BadOptME:	moveq	#'m',d0
		bra.s	BadOptEx
TooLarge:	lea	cS_TooLarge(pc),a1

Faulty:		lea	cS_Error(pc),a0
		bsr	Puts
		move.l	a1,a0
		bsr	Puts

FailExit:	move.w	#15,s_error(a5)
		bra.s	Exit

ControlC_Key:	PUTS CTRL_C
Abort:		move.w	#20,s_error(a5)
		PUTS Abort
		bra.s	Exit

ShowUsage:	PUTS Usage

Exit:		btst.b	#xALLOCATE,c_flags(a5)
		beq.s	.notallocd
		bsr	Deallocate
		move.l	awp_KeyTable(a5),a1
		move.l	l_KeyTable(a5),d0
		CCALL_LIB Sys,FreeMem

.notallocd:	bsr	CloseDevice

		btst.b	#xINHIBIT,c_flags(a5)
		beq.s	.notnecces
		moveq	#0,d0			; action Enable
		move.l	sp_InProc(a5),a0	; for InputDevice
		bsr	SendInhibit
		btst.l	#ONEDRIVE,d7
		bne.s	.notnecces
		moveq	#0,d0			; action Enable
		move.l	sp_OutProc(a5),a0	; for OutputDevice
		bsr	SendInhibit

.notnecces:	move.l	acp_TBptr(a5),a1
		move.l	a1,d0
		beq.s	.freed
		move.l	l_TBlen(a5),d0
		CCALL_LIB Sys,FreeMem
.freed:		clr.l	acp_TBptr(a5)
		bsr	AddBitPlane
		bclr.b	#xINHIBIT,c_flags(a5)
		btst.b	#xPORTADDED,c_flags(a5)
		beq.s	.removed
		lea	ReplyPort(a5),a1
		CCALL_LIB Sys,RemPort

.removed:	move.w	s_error(a5),d7

NoLibs:		CLOSELIB Int
		CLOSELIB Dos
		move.l	l_panic(a5),a7		; CpBuffer is invalid from here !!!
		move.l	#(VariLen+7)&$fff8,d0
		move.l	a5,a1
		CCALL_LIB Sys,FreeMem
		move.l	d7,d0
		ext.l	d0
		rts

; wWwWwWwWwWwWwWwWwWwWwWw  Hard Work  wWwWwWwWwWwWwWwWwWwWwWwWw
; Here all the hard work is done:

; ---------------------------------------------------------
; ***********  Check Disk structure  ******************
; Register Usage:
;   d7 - flags (throughout whole prg)
;   a4 - HeaderKeyBase  0(a4,d0.w) if d0.w= 2*Block#
;   a3 - DirStackBase   -(a3) to fill
;   a2 - HashBack - where did I get this Blocknumber
CheckStruct:	lea	BitMap(a5),a0
		move.l	a0,acp_BitMap(a5)
		bsr	ClearSector
		moveq	#0,d0		; get boot-sector
		bsr	BlockAdr
		move.l	l_InFS(a5),d0
		cmp.l	(a1),d0
		beq.s	.fsok
		eor.w	#1,d0
		cmp.l	(a1),d0
		beq	DiffFS

		move.l	(a1),d0
		CPRINTF <10," ! FileSystem - identification in BootBlock is $%08lx",10>,<d0,l>
		btst.l	#UNDELETE,d7
		beq	BadFormat

		lea	cS_ForceDOS(pc),a0
		bsr	Confirm
		bne	Exit
		move.l	l_InFS(a5),(a1)		; set DOS-type in BootBlock

.fsok:		move.l	l_InRoot(a5),d3	; new=old Root ...
		move.l	d3,l_newheader(a5)
		bsr	CheckSetUp	; a1:*Buffer ROOT on return
		bsr	TestChkSum
		cmp.l	#2,(a1)		; test Type for T.SHORT
		bne	.NoRoot
		cmp.l	#1,STYPE(a1)
		bne	.NoRoot
		clr.l	OWNKEY(a1)
		moveq	#SIZE-56,d0
		move.l	d0,HTSIZE(a1)
		move.w	d0,s_htsize(a5)
		clr.l	OWNKEY(a1)		; we are ignorant and just
		clr.l	HASHCHAIN(a1)		; poke in the correct values
		clr.l	PARENT(a1)		;
		clr.l	SEQUENCE(a1)		;
		bclr.l	#BMVALID,d7
		lea	BMFLAG(a1),a0
		move.l	(a0),d0
		beq.s	.bminv

		move.l	BMBLOCK(a1),d0
		cmp.l	l_InBlocks(a5),d0
		bcc.s	.bminv
		cmp.w	#1,d0
		bls.s	.bminv
		bset.l	#BMVALID,d7
		move.w	d0,s_bmblock(a5)
		bsr	BitMapPTR
		bset.b	d0,(a0)			; mark it as used
		lea	BMFLAG+8(a1),a0

.bminv:		lea	(SIZE-24)*4(a1),a2
.clrloop:	clr.l	(a0)+
		cmp.l	a2,a0
		bls.s	.clrloop
		move.w	d3,d0
		bsr	BitMapPTR
		bset.b	d0,(a0)

		bclr.b	#xUNDEL,c_flags(a5)
		lea	cS_Root(pc),a2		; parameter for 'Scanning'
		bsr	ChrDirectory
		bset.l	#SCHECKED,d7
		bsr	Undelete
		bsr	UpdateInd
		move.w	s_bmblock(a5),d2
		bne.s	.wehaveone
; look for an empty sector to place our BitMap
		moveq	#2,d2
.bmloop:	move.l	d2,d0
		add.w	d0,d0
		move.w	0(a4,d0.w),d0
		beq.s	.wehaveone
		cmp.w	#-2,d0
		beq.s	.wehaveone
		addq.w	#1,d2
		cmp.w	s_InBlocks(a5),d2
		bcs.s	.bmloop
		bra	DiskFull
.wehaveone:	move.w	d2,d0
		add.w	d0,d0
		move.w	#-1,(a4,d0.w)
		move.w	s_InRoot(a5),d0
		bsr 	BlockAdr
		move.l	d2,BMBLOCK(a1)
		move.l	#-1,BMFLAG(a1)
		bset	#BMVALID,d7

		move.w	s_InRoot(a5),d0
		bsr	BlockAdr
		addq.l	#1,CREATICKS(a1)	; causes less DOS-lockups
		bsr	DOSchksum
		move.w	s_InBlocks(a5),d1
		bsr	MakeBitMap
		PUTS	NewLine
		move.w	s_InRoot(a5),d0		; get ROOTBLOCK#
		lea	cS_Checked(pc),a2
		bsr	ShowFree
		rts

.NoRoot:	btst.l	#UNDELETE,d7
		beq	BadFormat
		lea	cS_NoRoot(pc),a0
		bsr	Confirm
		bne	Exit
		bsr	BlockAdrD2
		move.l	a1,a0
		bsr	ClearSector
		move.l	#2,(a1)
		move.l	#1,STYPE(a1)
		move.b	#50,NAME(a1)		; when ConvertBSTR is called, the
		clr.l	BMFLAG(a1)		; mark Bitmap invalid
		bra	.fsok			; name !Lazarus will be used ...

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ChDirectory:	move.w	d3,d0
		bsr	BlockAdr
		ext.l	d3
		clr.l	HTSIZE(a1)
		lea	cS_Directory(pc),a2	; parameter for 'Scanning'

ChrDirectory:	clr.l	EXTENSION(a1)
		clr.l	FIRST(a1)
		moveq	#-1,d0
		movem.w	d0/d2/d3/d4,-(a3)
;			6(a3)	next in hashchain
;			4(a3)	current Key# as Parent
;			2(a3)	do it again to have same size as in Rearrange
;			(a3)	Hash-Slot Counter
		bsr	Scanning
		addq.w	#2,s_dirlevel(a5) ; increment by 2 for TabbingIn

.EntryLoop:	move.l	(a2),d2
		bne.s	.NextEntry
		addq.w	#1,(a3)
		move.w	(a3),d1
		cmp.w	s_htsize(a5),d1
		bcc	ChNextLevel
		lsl.w	#2,d1
		move.l	acp_CurDir(a5),a0
		lea	HASHTABLE(a0,d1.w),a2
		bra.s	.EntryLoop

.NextEntry:	bsr	TestSRCblock
		beq.s	.validkey
.badkey:	bsr	WarnBadHash
		bra.s	.EntryLoop
.double:	bsr	DoubleHashed
		bra.s	.EntryLoop

.validkey:	bsr	BitMapPTRD2
		btst.b	d0,(a0)		; is this block already used ?
		bne.s	.double		; yes, so remove second reference
		bset.b	d0,(a0)		; no? - then it is used now !!
		bsr	TestOptF		; shouldn't be possible
		beq.s	.badkey
		move.l	d2,l_newheader(a5)
		bsr	TestChkSum
		cmp.l	#2,(a1)		; is this key allowed for Chaining ?
		bne.s	.badkey
		cmp.l	#2,STYPE(a1)
		beq.s	.legalst
		cmp.l	#-3,STYPE(a1)
		bne.s	.badkey

.legalst:	bsr	ConvertBSTR
		move.w	s_hash(a5),d0
		cmp.w	(a3),d0
		bls.s	.goodhash	; we just handle early hashs here
		bsr	BitMapPTRD2
		bclr.b	d0,(a0)		; wait for your turn ...

.badhash:	bsr	ReHash		; the rest is taken care of after processing
		bra.s	.EntryLoop

.goodhash:	bsr	TestOwn		; we just poke over the old value ...
		btst.l	#VERBOOSE,d7
		beq.s	.quiet
		bsr	TabbingIn
		CPRINTF <" [%4d] ">,<d2,w>
.quiet:		move.w	4(a3),d0	; get back Parent Key#
		ext.l	d0
		move.l	d0,PARENT(a1)	; again we just poke over the old value
		cmp.l	#-3,STYPE(a1)
		beq.s	.FileHeader

.UserDir:	bsr	ShowUserDir
		clr.l	SEQUENCE(a1)
		move.w	d2,d0
		add.w	d0,d0
		move.w	d2,0(a4,d0.w)	; create entry in HeaderKeyTable
.nextHeader:	move.w	s_hash(a5),d0
		cmp.w	(a3),d0
		bcs.s	.badhash
		lsl.w	#2,d0
		move.l	acp_CurDir(a5),a0	; here a directory is
		lea	HASHTABLE(a0,d0.w),a0	; moved to the
		cmp.l	a0,a2			; first place in the
		beq.s	.firstinch		; hashchain, if it
		move.l	HASHCHAIN(a1),(a2)	; is not already there
		move.l	(a0),HASHCHAIN(a1)
		move.l	d2,(a0)
		bra	.EntryLoop
.firstinch	lea	HASHCHAIN(a1),a2
		bra	.EntryLoop
; - - - - - - - - - - - - - -
.FileHeader:	bsr	ShowFileHeader
		move.l	BLOCKN0(a1),FIRST(a1) ; once again - oh we're so ignorant
		bsr	TraceFile
		beq.s	.goodfile
.aloud:		CPRINTF <"REMOVED [%4d] %6ld '%s' {seq#%4ld}=[%4ld]",10>,<d2,w>,
&			<BYTESIZE(a1),l>,NameBuf(a5),<l_sequence(a5),l>,<l_realkey(a5),l>
		addq.w	#1,s_removed(a5)
		move.l	HASHCHAIN(a1),(a2)
		bra	.EntryLoop

.goodfile:	bsr	AddFile
		move.w	s_hash(a5),d0
		cmp.w	(a3),d0
		bcs	.badhash
		lea	HASHCHAIN(a1),a2
		bra	.EntryLoop
; - - - - - - - - - - - - - -
ChNextLevel:	move.w	#-1,(a3)	; reset Hash-Slot counter
		moveq	#0,d4

.NLloop:	tst.w	d4
		bne.s	.NLhash
		move.w	2(a3),d0
		bsr	BlockAdr
.emptyslot:	addq.w	#1,(a3)
		move.w	(a3),d1
		cmp.w	s_htsize(a5),d1
		bcc.s	.EndLevel
		lsl.w	#2,d1
		lea	HASHTABLE(a1,d1.w),a2
		move.l	(a2),d4
		beq.s	.emptyslot
.NLhash:	move.l	d4,d3
		move.l	d3,d2
		bsr	BlockAdrD2
		move.l	HASHCHAIN(a1),d4
		cmp.l	#2,STYPE(a1)
		beq.s	.NLdir
		bsr	DOSchksum
		bra.s	.NLloop

.NLdir:		move.w	s_maxdirs(a5),d0
		cmp.w	s_dirlevel(a5),d0
		bls	DirTooDeep
		bsr	ChDirectory
		bra.s	.NLloop

.EndLevel:	move.w	2(a3),d0
		bsr	BlockAdr
		bsr	DOSchksum

		bsr	TestBreak
		movem.w	(a3)+,d0/d2/d3/d4
		subq.w	#2,s_dirlevel(a5)

		rts
; - - - - - - - - - - - - - - - - - - - - - - - -
TraceFile:	movem.l	a1/a2/d2,-(a7)
		move.l	a7,l_TFstack(a5)
		clr.l	acp_lastdata(a5)
		clr.l	l_sequence(a5)
.loop:		move.l	a1,acp_next(a5)
		move.l	COUNT(a1),d3
		move.w	s_htsize(a5),d0
		ext.w	d0
		cmp.l	d0,d3
		bhi	.badfile
		lea	BLOCKN0+4(a1),a2
.nextdata:	tst.w	d3
		bne.s	.HaveSector
		move.l	acp_next(a5),a1
		move.l	EXTENSION(a1),d2
		beq	.goodfile
		bsr	TestSRCblock
		bmi	.badfile
		bsr	BitMapPTRD2
		btst.b	d0,(a0)
		bne	.badfile
		bsr	TestOptF		; shouldn't be possible
		beq	.badfile
		bsr	TestChkSum
		cmp.l	#$10,(a1)
		bne.s	.badfile
		cmp.l	#-3,STYPE(a1)
		bne.s	.badfile
		move.l	l_newheader(a5),d0
		cmp.l	PARENT(a1),d0
		bne.s	.badfile
		bsr	BitMapPTRD2
		bset.b	d0,(a0)
		bsr	TestOwn
		clr.l	HASHCHAIN(a1)
		bsr	TestFLfirst
		clr.l	DATASIZE(a1)
		bra.s	.loop

.HaveSector:	subq.w	#1,d3
		move.l	-(a2),d2
		bsr	TestSRCblock
		bmi.s	.badfile
		bsr	BitMapPTRD2
		btst.b	d0,(a0)
		bne.s	.verybad
		bsr	TestOptF
		beq.s	.badfile		; shouldn't be possible
		addq.l	#1,l_sequence(a5)
		btst.l	#FFS,d7
		bne.s	.isFFS
		bsr	TestChkSum
		cmp.l	#8,(a1)
		bne.s	.badfile
		move.l	l_newheader(a5),d0
		cmp.l	FHEADER(a1),d0		; FHEADER was used before KS2.0
		beq.s	.preKS20
		cmp.l	OWNKEY(a1),d2		; now it serves as OWNKEY
		bne.s	.badfile
.preKS20:	bsr	TestSequence		; verify SEQUENCE und NEXT
		move.l	a1,acp_lastdata(a5)
		bsr	BitMapPTRD2
		bset.b	d0,(a0)
.isFFS:		bra	.nextdata

.badfile:	move.l	d2,l_realkey(a5)
		movem.l	(a7)+,a1/a2/d2
		moveq	#-1,d0
		rts
.goodfile:	moveq	#0,d2		; NEXT in last data block is 00
		bsr	TestNext
		movem.l	(a7)+,a1/a2/d2
		moveq	#0,d0
		rts

.verybad:	btst.b	#xUNDEL,c_flags(a5)
		bne.s	.badfile
		btst.l	#FFS,d7
		beq.s	.badfile
		bsr.s	.showmess
		bra.s	.badfile
.showmess:	movem.l	d0/a0,-(a7)
		lea	cS_LinkConf(pc),a0
		bra	TSwarn
; ---------------------------------------------------------
; AddFile(d2:headerblock,a1:*buffer of Header)		?: d0-d3/a0/a2
AddFile:	movem.l	a1/a2/d2,-(a7)
.loop1:		bsr	DOSchksum
		move.l	a1,acp_next(a5)
		bsr.s	AllocBlock
		bsr	BitMapPTRD2
		bset.b	d0,(a0)
		lea	BLOCKN0+4(a1),a2
		move.l	COUNT(a1),d3
.loop2:		tst.w	d3
		bne.s	.data
		move.l	acp_next(a5),a1
		move.l	EXTENSION(a1),d2
		beq.s	.last
		bsr	BlockAdrD2
		bra.s	.loop1
.last:		movem.l	(a7)+,a1/a2/d2
		rts

.data:		subq.w	#1,d3
		move.l	-(a2),d2
		bsr	BitMapPTRD2
		bset.b	d0,(a0)
		btst.l	#FFS,d7
		bne.s	.ffsskip
		bsr	BlockAdrD2
		bsr	DOSchksum
.ffsskip:	bsr.s	AllocBlock
		bra.s	.loop2

; ---------------------------
AllocBlock:	move.w	d2,d0
		add.w	d0,d0
		move.w	d2,0(a4,d0.w)
		rts
; ---------------------------------------------------------
Undelete:	btst.l	#UNDELETE,d7
		beq.s	.back
		bset.b	#xUNDEL,c_flags(a5)	; that's for TraceFile
		PUTS NewLine
		moveq	#2,d2
.loop:		bsr	BitMapPTRD2
		btst.b	d0,(a0)
		beq.s	.maybe
.next:		addq.w	#1,d2
		cmp.w	s_InBlocks(a5),d2
		bcs.s	.loop
		move.w	s_InRoot(a5),d0
		bsr	BlockAdr
		bsr	DOSchksum
.back:		rts

.maybe:		bsr	BlockAdrD2
		beq.s	.next
		cmp.l	#2,(a1)		; test for Header-block
		bne.s	.next
		cmp.l	OWNKEY(a1),d2
		bne.s	.next
		cmp.l	#-3,STYPE(a1)
		bne.s	.next
		move.l	d2,l_newheader(a5)
		bsr	TraceFile
		bmi.s	.next
		tst.w	s_undel(a5)
		bne.s	.notfirst
		btst.l	#FFS,d7
		beq.s	.notfirst
		PUTS	Dangerous

.notfirst:	bsr	ConvertBSTR
		CPRINTF <" Restore deleted File [%4d] %6ld '%s'">,
&			<d2,w>,<BYTESIZE(a1),l>,NameBuf(a5)
		lea	cS_Empty(pc),a0
		bsr	Confirm
		bne	.next
.restorefile:	move.l	a1,a2
		move.l	l_InRoot(a5),d0
		move.l	d0,PARENT(a2)
		bsr	BlockAdr
		move.w	s_hash(a5),d0
		lsl.w	#2,d0
		move.l	HASHTABLE(a1,d0.w),HASHCHAIN(a2)
		move.l	d2,HASHTABLE(a1,d0.w)
		lea	cS_Comment(pc),a0
		btst.l	#FFS,d7
		beq.s	.noffs
		lea	cS_FFScomment(pc),a0
.noffs:		lea	cS_Commentt(pc),a1
		sub.l	a0,a1
		move.l	a1,d1
		lea	COMMENT(a2),a1
		move.b	d1,(a1)+
		subq.w	#1,d1
.comment:	move.b	(a0)+,(a1)+
		dbf	d1,.comment
		move.l	a2,a1
		bsr	DOSchksum
		bsr	AddFile
		addq.w	#1,s_undel(a5)
		bra	.next

; ---------------------------
DoubleHashed:	lea	cS_Double(pc),a0
		bra.s	WBHn
WarnBadHash:	lea	cS_BadHash(pc),a0

WBHn:		CPRINTF <" ! warning: (%ld) %s - removed from HashChain",10>,<(a2),l>,<a0,l>
		addq.l	#1,l_warnings(a5)
		clr.l	(a2)
		rts

; ---------------------------
ShowFree:	bsr	BlockAdr
		bsr	ConvertBSTR
		CPRINTF <" Disk '%s' %s %d Blocks free",10>,
&		NameBuf(a5),<a2,l>,<s_free(a5),w>
		rts
; ---------------------------
TestFLfirst:	movem.l	d0/a0,-(a7)
		tst.l	FIRST(a1)
		beq	TSback
		clr.l	FIRST(a1)
		lea	cS_FLnofirst(pc),a0
		bra.s	TSwarn
TestOwn:	movem.l	d0/a0,-(a7)
		cmp.l	OWNKEY(a1),d2
		beq.s	TSback
		move.l	d2,OWNKEY(a1)
		lea	cS_WrongOwn(pc),a0
		bra.s	TSwarn
TestChkSum:	movem.l	d0/a0,-(a7)
		bsr	CheckSum
		beq.s	TSback
		cmp.l	l_newheader(a5),d2
		bne.s	.go
		move.l	d1,-(a7)
		bsr	BlockAdrD2
		bsr	ConvertBSTR
		move.l	(a7)+,d1
.go:		lea	cS_BadChkSum(pc),a0
TSwarn:		btst.b	#xUNDEL,c_flags(a5)
		bne.s	TSgetback
		CPRINTF <" ! warning: in (%4d) of [%4ld] '%s' -- %s",10>,<d2,w>,
&			<l_newheader(a5),l>,NameBuf(a5),<a0,l>
		addq.l	#1,l_warnings(a5)
TSback:		movem.l	(a7)+,d0/a0
		rts

TSgetback:	move.l	l_TFstack(a5),a7	; remove the return Address to TracFile
		movem.l	(a7)+,a1/a2/d2		; simulate a .badfile exit for Undelete
		moveq	#-1,d0
		rts
; - - - - - - - - - - - - - - - - - - -
TestSequence:	movem.l	d0/a0,-(a7)
		move.l	SEQUENCE(a1),d0
		cmp.l	l_sequence(a5),d0
		beq.s	TestNext1
		move.l	l_sequence(a5),SEQUENCE(a1)
		lea	cS_BadSequence(pc),a0
		bra.s	TSwarn

TestNext:	movem.l	d0/a0,-(a7)
TestNext1:	move.l	acp_lastdata(a5),d0
		beq.s	TSback
		move.l	d0,a0
		move.l	NEXT(a0),d0
		cmp.l	d0,d2
		beq.s	TSback
		move.l	d2,NEXT(a0)
		lea	cS_BadNext(pc),a0
		bra	TSwarn

TestOptF:	bsr	BlockAdrD2
		beq.s	.where
.back:		rts
.where:		btst.l	#ECONOMY,d7
		beq.s	.back
		cmp.w	#-2,d0		; was it a bad Sector ??
		beq.s	.back
		CPRINTF <10," ! (%4d) Missing Block, try again without option -e",10>,<d2,w>
		bra	FailExit

; ---------------------------
; ReHash(d2:HeaderKey#,acp_CurDir(a5):*buffer ParentDir)	?: a0/a1/d0/d1
ReHash:		bsr	BlockAdrD2	; get *buffer of Current Header
		move.l	HASHCHAIN(a1),(a2)	; get us out of old Chain
	; next Element in Chain (a2) will be processed by main,
	; so we don't care for its integrity
		move.w	s_hash(a5),d1
		move.l	acp_CurDir(a5),a0
		lsl.w	#2,d1
		move.l	HASHTABLE(a0,d1.w),HASHCHAIN(a1)
		move.l	d2,HASHTABLE(a0,d1.w)
		bsr	DOSchksum

		CPRINTF <" ! [%4d] warning: Header '%s' moved to correct hash-position",10>,
&			<d2,w>,NameBuf(a5)
		addq.l	#1,l_warnings(a5)
		rts

; -----------------------------------------------
; get the indirection Table up to date
UpdateInd:	move.l	awp_KeyTable(a5),a1
		btst.l	#INDREF,d7
		beq.s	.wasntind
		moveq	#2,d2
.adapt:		move.w	d2,d1
		add.w	d1,d1
		move.w	0(a4,d1.w),d0
		bpl.s	.look
		cmp.w	#-1,d0
		beq.s	.bitmap
		moveq	#0,d0
.look:		add.w	d0,d0
		move.w	0(a1,d0.w),d0
		bpl.s	.bitmap
		moveq	#0,d0
.bitmap:	move.w	d0,0(a4,d1.w)
		addq.w	#1,d2
		cmp.w	s_TableSize(a5),d2
		bcs.s	.adapt

.wasntind:	move.w	s_TableSize(a5),d2
		subq.w	#1,d2
		move.l	a4,a0
		move.l	a1,a4		; we need that for empty block search
.copyloop:	move.w	(a0)+,(a1)+
		dbf	d2,.copyloop

		bset.l	#INDREF,d7
		rts
; ---------------------------
Scanning:	bsr	ConvertBSTR
		btst.l	#VERBOOSE,d7
		beq.s	.scanQuiet
		bsr	TabbingIn
		CPRINTF <"  Scanning %s '%s'",10>,<a2,l>,NameBuf(a5)
.scanQuiet:	move.l	a1,acp_CurDir(a5)	; keep *Buffer for this Directory
		move.l	a4,a2			; no next hashentry (a4) should be 0000
		rts
; ---------------------------
ShowUserDir:	btst.l	#VERBOOSE,d7
		beq.s	.quiet
		CPRINTF <" (dir) '%s'",10>,NameBuf(a5)
.quiet:		rts
; ---------------------------
ShowFileHeader:	btst.l	#VERBOOSE,d7
		beq.s	SFHquiet
ShowFileHead2:	CPRINTF <"%6ld '%s'",10>,<BYTESIZE(a1),l>,NameBuf(a5)
SFHquiet:	rts
; ---------------------------
CheckSetUp:	move.l	l_InRoot(a5),d2		; get ROOTBLOCK # in d2
		bsr	BlockAdrD2
		move.l	HTSIZE(a1),d0
		move.w	d0,s_htsize(a5)
		move.l	acp_TBptr(a5),a4		; get HeaderAdrBase
		move.l	a4,a0
		move.l	l_TBlen(a5),d1
		lsr.l	#1,d1
		subq.l	#1,d1

		move.w	#(MAX_DIRS-1)*2,s_maxdirs(a5)
		moveq	#0,d0
.clrloop:	move.w	d0,(a0)+		; clean up HeaderAdrBase area
		dbf	d1,.clrloop
		move.l	a0,a3			; set Dirstack-Base
		move.w	d3,d0
		add.w	d0,d0
		move.w	d2,0(a4,d0.w)		; mark RootBlock
		rts
; ---------------------------------------------------------
; ***********  Rearrange Disk structure  ******************
; Register Usage:
;   d7 - flags (throughout whole prg)
;   d6 - s_narrowsec
;   d5 - s_farsec
;   a4 - HeaderKeyBase  0(a4,d0.w) if d0.w= 2*Block#
;   a3 - DirStackBase   -(a3) to fill
;   a2 - HashBack - where did I get this Blocknumber

Rearrange:	move.l	l_OutRoot(a5),d3		; set new Parent Key#
		bsr.s	CheckSetUp
		move.w	#-1,-2(a4,d0.w)		; mark BitmapBlock
		move.l	d3,d0
		subq.l	#1,d0
		move.w	d0,s_bmblock(a5)
		bclr.l	#BMVALID,d7		; we're going to mess up the disk ...
		move.l	d0,BMBLOCK(a1)		; adjust Bitmap reference in
		move.l	#-1,BMFLAG(a1)		; RootBlock and mark it valid
		moveq	#1,d5			; s_lowersec = 1 by default
		move.l	l_OutBlocks(a5),d6	; s_uppersec = s_OutBlocks by default
		move.w	s_free(a5),d0
		ext.l	d0
		add.l	d6,d0
		sub.l	l_InBlocks(a5),d0
		bmi	DiskFull
		subq.l	#4,d0
		bmi.s	.usual
		moveq	#0,d1
		tst.w	s_Reserve(a5)
		beq.s	.tight
		move.l	d0,d1
		divu	s_Reserve(a5),d1	; reserve space for directory
.tight:		sub.w	d1,d0
		btst.l	#DESTINTD,d7
		beq.s	.symetric
		move.w	#132,d1
		cmp.w	d1,d0
		bhi.s	.more
		move.l	d0,d1
.more:		sub.w	d1,d6
		sub.w	d1,d0
.symetric:	lsr.w	#1,d0
		cmp.w	#5,d0
		bls.s	.usual
		add.w	d0,d5			; leave free area at both
		sub.w	d0,d6			; ends of the media

.usual:		move.w	d6,s_uppersec(a5)
		move.l	d3,d6			; get l_OutRoot in s_narrowsec

		clr.w	s_dirlevel(a5)
		lea	cS_Root(pc),a2		; parameter for 'Scanning'
		bsr.s	RerDirectory
;
		bsr	UpdateInd
		move.w	s_OutBlocks(a5),s_InBlocks(a5)	; for debugging purposes, when we want
		move.w	s_OutRoot(a5),s_InRoot(a5)	; to run CheckStruct again ...

		move.w	s_OutBlocks(a5),d1
		bsr	MakeBitMap

		move.w	s_OutRoot(a5),d0		; get ROOTBLOCK#
		lea	cS_Rearranged(pc),a2
		bsr	ShowFree
		bset.l	#REARRANGED,d7
		rts

; ------------------------------
ReDirectory:	lea	cS_Directory(pc),a2		; parameter for 'Scanning'
RerDirectory:	bsr	BlockAdrD2
		moveq	#-1,d0
		movem.w	d0/d2/d3/d4,-(a3)
;				6(a3)	; next in hashchain
;				4(a3)	; new parent key#
;				2(a3)	; old parent key#
;				(a3)	; current Hash-Slot #
		ext.l	d3
		move.l	d3,l_Parent(a5)
		bsr	Scanning
		addq.w	#2,s_dirlevel(a5) ; we increment by 2 for TabbingIn

.EntryLoop:	move.l	(a2),d2
		bne.s	.NextEntry
		addq.w	#1,(a3)
		move.w	(a3),d1
		cmp.w	s_htsize(a5),d1
		bcc	ReNextLevel
		lsl.w	#2,d1
		move.l	acp_CurDir(a5),a0
		lea	HASHTABLE(a0,d1.w),a2
		bra.s	.EntryLoop

.NextEntry:	bsr	BlockAdrD2
		bsr	ConvertBSTR
		bsr	GetNarrowSec
		move.l	d0,OWNKEY(a1)		; adjust OwnKey reference
		move.l	d0,(a2)
		move.l	d0,l_newheader(a5)
		btst.l	#VERBOOSE,d7
		beq.s	.quiet
		bsr	TabbingIn
		CPRINTF	<" [%4d  old:%4d] ">,<d0,w>,<d2,w>
.quiet:		move.l	l_newheader(a5),d2
		move.w	4(a3),d0
		ext.l	d0
		move.l	d0,PARENT(a1)		; adjust Parent reference
		move.l	STYPE(a1),d0
		cmp.l	#-3,d0
		beq.s	.FileHeader

.UserDir:	bsr	ShowUserDir
		lea	HASHCHAIN(a1),a2
		bra	.EntryLoop
; - - - - - - - - - - - - - -
.FileHeader:	bsr	ShowFileHeader
		move.l	BYTESIZE(a1),d1
		bclr.l	#PREFERRED,d7
		bsr	TestInfo
		bne.s	.noinfo
		cmp.l	l_maxleni(a5),d1
		bhi.s	.notpref
.prefd:		bset.l	#PREFERRED,d7
		bra.s	.notpref
.noinfo:	cmp.l	l_maxlena(a5),d1
		bls.s	.prefd
.notpref:	move.l	a1,-(a7)
		bsr.s	ReCopyFile
		move.l	(a7)+,a1
		move.l	BLOCKN0(a1),FIRST(a1)
		lea	HASHCHAIN(a1),a2
		bra	.EntryLoop

; - - - - - - - - - - -
ReCopyFile:	clr.l	acp_lastdata(a5)

.listblock:	move.l	a1,acp_next(a5)
		move.l	COUNT(a1),d3
		lea	BLOCKN0+4(a1),a2
.loop:		tst.w	d3
		bne.s	.HaveSector
		move.l	acp_next(a5),a1
		lea	EXTENSION(a1),a2
		move.l	(a2),d2
		bne.s	.nextFL
		moveq	#0,d0
		bra.s	ReAdjustLast
.nextFL:	bsr	BlockAdrD2
		bsr	GetFLSector
		move.l	d0,(a2)
		move.l	l_newheader(a5),PARENT(a1)
		move.l	d0,OWNKEY(a1)
		bra.s	.listblock		; checksum is fixed in ReNextLevel

.HaveSector:	subq.w	#1,d3
		move.l	-(a2),d2
		bsr	GetSector
		move.l	d0,(a2)
		bsr.s	ReAdjustLast
		bne.s	.isffs
		bsr	BlockAdrD2
		move.l	l_newheader(a5),FHEADER(a1)	; I deny KS 2.0 convention !!!
		move.l	a1,acp_lastdata(a5)
.isffs:		bra.s	.loop

ReAdjustLast:	btst.l	#FFS,d7
		bne.s	.ffs
		move.l	acp_lastdata(a5),d1
		move.l	d1,a1
		beq.s	.noffs		; there was no data sector before the current one
		move.l	d0,NEXT(a1)
		bsr	DOSchksum
.noffs:		SETZERO
.ffs:		rts
; - - - - - - - - - - -
; scan each Directory again and call Directory for each UserDir
ReNextLevel:	move.w	#-1,(a3)	; reset Hash-Slot counter
		moveq	#0,d4		; no HashChain yet

.NLloop:	tst.w	d4
		bne.s	.NLhash
		move.w	2(a3),d0	; get old Block# of CurDir
		bsr	BlockAdr
.emptyslot:	addq.w	#1,(a3)
		move.w	(a3),d1
		cmp.w	s_htsize(a5),d1
		bcc.s	.EndLevel
		lsl.w	#2,d1
		lea	HASHTABLE(a1,d1.w),a2
		move.l	(a2),d4
		beq.s	.emptyslot
.NLhash:	move.w	d4,d3
		add.w	d4,d4
		move.w	0(a4,d4.w),d2
		bsr	BlockAdrD2
		move.l	HASHCHAIN(a1),d4
		cmp.l	#2,STYPE(a1)
		beq.s	.NLdir
.adjchksum:	bsr	DOSchksum
		move.l	EXTENSION(a1),d0	; fix CheckSum of FileHeader
		beq.s	.NLloop			; and FileList Blocks
		add.w	d0,d0
		move.w	0(a4,d0.w),d0		; get old Block#
		bsr	BlockAdr
		bra.s	.adjchksum

.NLdir:		move.w	s_maxdirs(a5),d0
		cmp.w	s_dirlevel(a5),d0
		bls	DirTooDeep
		bsr	ReDirectory
		bra.s	.NLloop

.EndLevel:	move.w	2(a3),d0		; get old Block# of rearranged Dir
		bsr	BlockAdr
		bsr	DOSchksum

		bsr	TestBreak
		movem.w	(a3)+,d0/d2/d3/d4
		subq.w	#2,s_dirlevel(a5) ; decrease Level-counter

		rts
; ---------------------------------------------------------
; d0.l:NewAllocatedBlock = GetSector(d2:oldBlock)	?: d0/d5/d6
GetFLSector:	btst.l	#LISTBLOCKS,d7
		beq.s	GetNarrowSec
GetSector:	btst.l	#PREFERRED,d7
		beq.s	GetFarSec
GetNarrowSec:	cmp.w	s_bmblock(a5),d6
		bcs.s	.down
		addq.w	#1,d6
		cmp.w	s_uppersec(a5),d6
		bcs.s	.up
		move.w	s_bmblock(a5),d6
.down:		subq.w	#1,d6
.up:		move.l	d6,d0
SetPointer:	cmp.w	d5,d6
		beq	DiskFull
		add.l	d0,d0
		move.w	d2,0(a4,d0.w)
		lsr.l	#1,d0
		rts

GetFarSec:	cmp.w	s_bmblock(a5),d5
		bhi.s	.down
		addq.w	#1,d5
		cmp.w	s_bmblock(a5),d5
		bcs.s	.up
		move.w	s_uppersec(a5),d5
.down:		subq.w	#1,d5
.up:		move.l	d5,d0
		bra.s	SetPointer
; ---------------------------------------------------------
; Create BitMap and count empty sectors
; d0:free Blocks = MakeBitMap(d1:s_InBlocks/s_Outblocks)	?: a0/a1/d0/d1
MakeBitMap:	movem.l	a2/d2/d3/d4,-(a7)
		move.w	d1,d3
		move.w	d3,d4
		lea	BitMap(a5),a0
		move.l	a0,acp_BitMap(a5)
		bsr	ClearSector
		moveq	#2,d2
		sub.w	d2,d3			; subtract bootblocks
		move.l	awp_KeyTable(a5),a2
.loop:		move.w	d2,d1
		add.w	d1,d1
		tst.w	0(a2,d1.w)
		bne.s	.block
		bsr	BitMapPTRD2
		bset.b	d0,(a0)
		bra.s	.free
.block:		subq.w	#1,d3
.free		addq.w	#1,d2
		cmp.w	d4,d2
		bcs.s	.loop

		move.l	acp_BitMap(a5),a1
		clr.l	(a1)
		bsr	CheckSum
		neg.l	d0			; adjust Bitmap - Checksum
		move.l	d0,(a1)
		bset.l	#BMVALID,d7
		move.w	d3,s_free(a5)
		movem.l	(a7)+,a2/d2/d3/d4
		rts

; -- IO -- IO -- IO -- IO -- IO -- IO -- IO -- IO -- IO -- IO --
; WriteDestin()					?: a0/a1/a4/d0/d1/d2/d3/d4
WriteDestin:	bclr.l	#MAYIGNORE,d7
		moveq	#0,d0
		bsr	BlockAdr
		move.l	(a1),l_keepfs(a5)		; keep orig FS identification
		move.l	#'COPY',(a1)			; and set Destination's to
		lea	acp_OutName-acp_InName(a5),a4
		bsr	SetUpRW			; Track-Counter in d4
		bne	.badwrite		; we're having trouble
		bclr.b	#xDISKIDENT,c_flags(a5)
		move.w	s_OutBlocks(a5),s_outbl(a5)	; 'COPY' until we're
		move.w	s_OutBPT(a5),s_bpt(a5)		; through
		bra.s	.writeloop

.Verror:	subq.b	#1,d6
		bpl.s	.Vagain
		PUTS StrangeVerify
		bra	.badwrite
.Vagain:	lea	cS_Rewriting(pc),a0
		bra.s	.renter

.writeloop:	move.w	#$101,d6		; Set both Retry Counters for Verify-Error
		lea	cS_Writing(pc),a0
.renter:	move.l	d4,d2
		move.w	s_bpt(a5),d5
		mulu	d5,d2			; new track base
		add.w	d2,d5			; last sector on track
		bsr	ShowTrack

.wloop:		moveq	#0,d3			; local sector counter
		move.l	acp_TBptr(a5),a2
.wCYLloop:	move.l	a2,a0
		bsr	BlockAdrD2
		bne.s	.whavedata
		bsr	ClearSector
		bra.s	.next
.whavedata:	exg.l	a0,a1
		jsr	MoveData
.next:		lea	SIZE*4(a2),a2
		addq.w	#1,d2			; increase Sector counter
		addq.w	#1,d3			; increase local Sector counter
		cmp.w	d5,d2
		bcc.s	.bufferfull
		cmp.w	#10,d3
		bls.s	.wCYLloop

.bufferfull:	move.l	d3,d0
		lsl.l	#8,d0
		add.l	d0,d0			; calc Buffer Length
		sub.w	d3,d2			; get back base
		moveq	#CMD_WRITE,d1
		btst.l	#DESTINTD,d7
		beq.s	.wnotd
		moveq	#TD_FORMAT,d1
.wnotd:		bclr.l	#VERIFYING,d7
		bsr	BlockIO
		bne	.badwrite
		add.w	d3,d2
		cmp.w	d5,d2
		bcs.s	.wloop

.trackfull:	moveq	#CMD_UPDATE,d1
		bsr	CommandIO
		bne	.badwrite
		moveq	#CMD_CLEAR,d1
		bsr	CommandIO
		bne	.badwrite
		btst.l	#NOVERIFY,d7
		bne.s	.noverify

.verify:	move.l	d4,d2
		mulu	s_bpt(a5),d2		; get trackbase
		lea	cS_Verifying(pc),a0
		bsr	ShowTrack
.vloop:		move.l	d5,d3
		sub.w	d2,d3
		cmp.w	#10,d3
		bls.s	.short
		moveq	#11,d3
.short:		move.l	d3,d0
		lsl.l	#8,d0
		add.l	d0,d0
		moveq	#CMD_READ,d1
		bset.l	#VERIFYING,d7
		bsr	BlockIO
		bmi	.badwrite
		bne	.Vagain

.vsecloop:	bsr	BlockAdrD2
		bne.s	.vhavedata
.vempty:	move.w	#SIZE-1,d1
.veloop:	tst.l	(a0)+
		bne	.Verror
		dbf	d1,.veloop
		bra.s	.vsecok
.vhavedata:	move.w	#SIZE-1,d1
.cmploop:	cmp.l	(a0)+,(a1)+
		bne	.Verror
		dbf	d1,.cmploop

.vsecok:	addq.w	#1,d2
		subq.w	#1,d3
		bne.s	.vsecloop
		cmp.w	d5,d2
		bcs.s	.vloop

.noverify:	bclr.l	#VERIFYING,d7
		addq.w	#1,d4			; increase Track-Counter
		cmp.w	s_outbl(a5),d2
		bcs	.writeloop

		moveq	#0,d2
		btst.b	#xDISKIDENT,c_flags(a5)
		bne.s	.back
		bset.b	#xDISKIDENT,c_flags(a5)
		moveq	#0,d4
		bsr	BlockAdrD2		; get Block 0
		move.l	l_keepfs(a5),(a1)	; Restore orig FS identification
		moveq	#11,d1			; we're going to rewrite
		move.w	d1,s_outbl(a5)		; Block 0-10 with the
		move.w	d1,s_bpt(a5)		; orig FS identification
		bne	.writeloop

.back:		moveq	#0,d0
		bsr	BlockAdr		; get Block 0
		move.l	l_keepfs(a5),(a1)	; Restore orig FS identification
		bclr.b	#xDISKIDENT,c_flags(a5)
		bsr	CloseDevice
		PUTS DNewLine
		tst.l	d2
		rts

.badwrite:	moveq	#-1,d2
		bra.s	.back
; - - - - - - - - - - - - - - - - - - -
SetUpRW:	bsr	OpenDevice
		bne.s	.back
		moveq	#0,d2			; Sector Counter
		moveq	#0,d4			; Track Counter
		moveq	#CMD_CLEAR,d1
		bsr	CommandIO
.back:		rts		; if not Z then error
; -------------------------------------
; ReadSource()					?: a0/a1/a4/d0/d1/d2/d4
ReadSource:	lea	(a5),a4
		bsr.s	SetUpRW
		beq.s	.readloop
		rts				; we're having trouble

.skippy:	addq.w	#1,d2
.readloop:	moveq	#0,d3
		moveq	#0,d5
.try:		cmp.w	s_InBlocks(a5),d2
		bcc	.readend

.loop1:		lea	cS_Reading(pc),a0
		bsr	ShowTrack
		bsr	BlockAdrD2
		or.l	d1,d5
		beq.s	.skippy
		addq.w	#1,d3
		btst.l	#SOURCETD,d7
		bne.s	.tdread
		addq.w	#1,d2
		cmp.w	s_InBlocks(a5),d2
		bcc.s	.bufferfull
		cmp.w	#10,d3
		bls.s	.loop1
.bufferfull:	move.l	d3,d0
		sub.w	d3,d2
		lsl.l	#8,d0
		add.l	d0,d0
		bra.s	.notd

.tdread:	move.w	#ETD_READ,d1
		bsr	OneBlockIO
		bne.s	.weiter
		bsr	TestSecLabel
		tst.l	d0
		bra.s	.weiter
.notd:		moveq	#CMD_READ,d1
		bsr	BlockIO
.weiter:	bmi	Abort
		move.l	a0,a2
		move.l	io_Actual+IOextTD(a5),d0
		lsr.l	#8,d0
		lsr.l	#1,d0
		cmp.w	d3,d0
		bcc.s	.good
		bset.l	#IOERROR,d7
		move.l	d0,d3
.good:		tst.w	d3
		beq.s	.copied
		bsr	BlockAdrD2
		beq.s	.skipone
		move.l	a2,a0
		bsr.s	MoveData
.skipone:	lea	SIZE*4(a2),a2
		addq.w	#1,d2
		subq.w	#1,d3
		bra.s	.good

.copied:	btst.l	#IOERROR,d7
		beq.s	.fini
.clear:		move.l	awp_KeyTable(a5),a0
		move.l	d2,d0
		add.w	d0,d0
		move.w	#-2,0(a0,d0.w)
		addq.w	#1,s_badblocks(a5)
.skipit:	addq.w	#1,d2
		btst.l	#SOURCETD,d7
		beq.s	.fini
		btst.b	#xTRACKSALVE,c_flags(a5)
		bne.s	.fini
		move.l	d2,d0		; If I am reading from a floppy
		divu	#11,d0		; drive, I will skip a whole
		swap	d0		; bad track, unless TrackSalve
		tst.w	d0		; is installed, who can still
		bne.s	.clear		; render me some good ones
.fini:		bclr.l	#IOERROR,d7
		bra	.readloop

.readend:	bsr	CloseDevice
		PUTS	DNewLine
		moveq	#0,d0
		rts
; ---------------------------
; d0:nextBuffer = ClearSector(a0:*Buffer)		?: d0
ClearSector:	movem.l	d1/a0,-(a7)
		moveq	#0,d0
		move.w	#SIZE-1,d1
.clrloop:	move.l	d0,(a0)+
		dbf	d1,.clrloop
		move.l	a0,d0
		movem.l	(a7)+,d1/a0
		rts
; ---------------------------
; MoveData(a0:Source,a1:Destination)			?: a0/a1/d0
MoveData:	moveq	#15,d0
.loop		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		dbf	d0,.loop
		rts
; ---------------------------
; TestSecLabel(d2.w:Block#,a0:*Buffer)			?: none
TestSecLabel:	movem.l	a0/a1/d0,-(a7)
		lea	SIZE*4+16(a0),a1
		move.l	-(a1),d0
		or.l	-(a1),d0
		or.l	-(a1),d0
		or.l	-(a1),d0
		beq.s	.back
		CPRINTF <" ! Found SLD in Block (%4d) : %08lx %08lx %08lx %08lx",10>,
&			<d2,w>,<(a1)+,l>,<(a1)+,l>,<(a1)+,l>,<(a1)+,l>
.back:		movem.l	(a7)+,a0/a1/d0
		rts
; ------------------------
; N-flag = BlockIO(d1:Command,d2:Block#,d0.w:Length[bytes],a4:* In/Out - Table)	?: a0/d0
OneBlockIO:	moveq	#-1,d0
		move.l	d0,iotd_Count+IOextTD(a5)
		move.l	acp_TBptr(a5),a0
		move.w	#SIZE*4,d0
		lea	0(a0,d0.w),a0
		move.l	a0,iotd_SecLabel+IOextTD(a5)	; put SecLabel behind Sector

BlockIO:	movem.l	a1/d1/d3,-(a7)
		ext.l	d0
		move.l	d0,-(a7)		; keep length
		move.w	d1,-(a7)		; keep command
		lea	IOextTD(a5),a1
		move.l	acp_TBptr(a5),io_Data(a1)
		move.l	d2,d0
		lsl.l	#8,d0
		add.l	d0,d0
		add.l	l_InOffset(a4),d0
		move.l	d0,io_Offset(a1)
		bsr	TestBreak
.retry:		moveq	#1,d3			; Retry Counter
.again:		move.w	(a7),io_Command(a1)
		move.l	2(a7),io_Length(a1)
		CALL_LIB Sys,DoIO
		bne.s	.IOError
		bclr.l	#IOERROR,d7
.back:		addq.l	#6,a7		; remove io_Command and io_Length
		movem.l	(a7)+,a1/d1/d3
		move.l	acp_TBptr(a5),a0
		tst.l	d0	; return condition:  N-flag = Abort
				;                    Z-flag = o.k.
		rts		;                not Z-flag = Ignore (if applicable)

.IOError:	lea	IOextTD(a5),a1
		move.b	io_Error(a1),d1
		ext.w	d1
		btst.l	#VERIFYING,d7
		beq.s	.notverify
		lea	cS_Verifying(pc),a0
		cmp.b	#TDERR_BadSecHdr,d1
		bhi.s	.show
		moveq	#1,d0
		sub.w	#$100,d6
		bpl.s	.back
		bra.s	.show

.notverify:	cmp.b	#TDERR_BadSecHdr,d1
		dbhi	d3,.again		; Retry soft errors d3 times

		cmp.b	#TDERR_WriteProt,d1
		bne.s	.notwrp
		bsr	MotorOff
		PUTS	WriteProt
		bra.s	.doask

.notwrp:	btst.l	#READING,d7
		beq.s	.notreading

.dontskip:	lea	cS_Reading(pc),a0
		bra.s	.show
.notreading:	lea	cS_Writing(pc),a0
.show:		move.w	d1,-(a7)
		bsr	MotorOff
		move.w	(a7)+,d1
		bset.l	#IOERROR,d7
		move.l	d2,d0
		divu	s_InBPT(a4),d0
		CPRINTF	<10," ! TD-Error #%d %s (%d) track %d : ">,
&			<d1,w>,<a0,l>,<d2,w>,<d0,w>
.doask:		bsr	AskRetry
		bne	.back
		btst.l	#VERIFYING,d7
		beq	.retry
		moveq	#1,d0
		bra	.back
; --------------------------------
; ShowTrack(a0:*ActionString,d2:Block#,a4:* In/Out-Table)	?: a0/d0/d1
ShowTrack:	move.l	d2,d0
		divu	s_InBPT(a4),d0
		swap d0
		tst.w	d0
		bne.s	.back
		btst.b	#xDISKIDENT,c_flags(a5)
		bne.s	.back
		swap	d0
		CPRINTF <" %s track %d   ",13>,<a0,l>,<d0,w>
		moveq	#0,d0
.back:		rts
; ---------------------------
; MotorOff() & CommandIO(d1.w=Command)				?: d0/d1

MotorOff:	moveq	#TD_MOTOR,d1		; Length=0 also turns off Motor
CommandIO:	moveq	#0,d0
		movem.l	a0/a1,-(a7)
		lea	IOextTD(a5),a1
		move.l	d0,io_Length(a1)
		move.w	d1,io_Command(a1)
		CCALL_LIB Sys,DoIO
		movem.l	(a7)+,a0/a1
		tst.l	d0
		rts
; --------------------------------
; OpenDevice(a4: In/Out - Table)			?:d0
OpenDevice:	movem.l	a0/a1/d1,-(a7)
		lea	IOextTD(a5),a1
		lea	ReplyPort(a5),a0
		move.l	a0,mn_ReplyPort(a1)
		move.l	acp_InDevice(a4),a0
		move.l	l_InUnit(a4),d0
		moveq	#0,d1			; flags: no flags
		CALL_LIB Sys,OpenDevice
		bne.s	.failed
		bset.l	#DEVOPEN,d7
.failed:	movem.l	(a7)+,a0/a1/d1
		tst.l	d0
		rts
; --------------------------------
; CloseDevice()						?: none
CloseDevice:	btst.l	#DEVOPEN,d7
		beq.s	.closed
		movem.l	d0/d1/a0/a1,-(a7)
		bsr.s	MotorOff
		lea	IOextTD(a5),a1
		CALL_LIB Sys,CloseDevice
		bclr.l	#DEVOPEN,d7
		movem.l	(a7)+,d0/d1/a0/a1
.closed:	rts
; -------------------------------------
; SendInhibit(d0:Arg1,a0:HandlerProc)			?: a0/a1/d0
SendInhibit:	movem.l	d1/a2,-(a7)
		lea	StdPacket(a5),a1
		lea	ReplyPort(a5),a2
		move.l	a2,mn_ReplyPort(a1)
		move.l	a2,$18(a1)		; set dp_MsgPort
		move.l	a1,$14(a1)		; set dp_Link
		lea	$14(a1),a2
		move.l	a2,ln_Name(a1)		; set Pointer to DosPacket
		move.l	d0,$28(a1)		; set Arg1
		moveq	#ACTION_INHIBIT,d0
		move.l	d0,$1c(a1)		; set dp_Type
		CCALL_LIB Sys,PutMsg
		lea	ReplyPort(a5),a0
		CCALL_LIB Sys,WaitPort
		lea	ReplyPort(a5),a0
		CCALL_LIB Sys,GetMsg		; I don't care for the Result
		movem.l	(a7)+,d1/a2
		rts

; -- Misc -- Misc -- Misc -- Misc -- Misc -- Misc -- Misc -- Misc --
; d1=a1:BufferAddress = BlockAdr(d0.w:Block#)			?: a1/d0/d1
; never mess with a0 in this routine !!!!!
BABitMap:	cmp.w	#-2,d0
		beq.s	BAback
		lea	BitMap(a5),a1
		move.l	a1,d1
		rts
BAback:		moveq	#0,d1
		rts

BlockAdrD2:	move.l	d2,d0
BlockAdr:	btst.l	#INDREF,d7
		beq.s	BAstraight
		cmp.w	#1,d0			; skip BootBlocks
		bls.s	BAstraight
		add.w	d0,d0		; make pointer for KeyTable
		move.l	awp_KeyTable(a5),a1
		move.w	0(a1,d0.w),d0
		beq.s	BAback		; We don't need this Sector : Z-flag set
		bmi.s	BABitMap

BAstraight:	move.l	app_DBptr(a5),a1
		move.l	d0,d1
		and.l	#31,d1
		lsl.l	#8,d1
		add.l	d1,d1
		lsr.w	#5,d0		; we have 32 blocks per DBptr
		lsl.w	#2,d0
		move.l	0(a1,d0.w),a1
		add.l	a1,d1
		move.l	d1,a1		; Z-flag never set; means Adr is ok.
		rts
; ---------------------------
; DOSchksum(a1:*BlockBuffer)				?: d0
DOSchksum:	clr.l	CHECKSUM(a1)
		bsr.s	CheckSum
		neg.l	d0
		move.l	d0,CHECKSUM(a1)
		rts
; - - - - - - - - - - -
; Z-flag = CheckSum(a1:*Buffer)				?: d0
CheckSum:	movem.l	a1/d1,-(a7)
		moveq	#0,d0
		move.w	#SIZE-1,d1
.chksloop:	add.l	(a1)+,d0
		dbf	d1,.chksloop
		movem.l	(a7)+,a1/d1
		tst.l	d0
		rts
; ---------------------------
; flags = TestSRCblock(d2.l:Block#)				?: none
TestSRCblock:	cmp.l	l_InBlocks(a5),d2
		bcc.s	.offscope
		cmp.w	#1,d2
		bls.s	.offscope

		SETZERO
		rts
.offscope:	SETNEG
		rts
; ---------------------------
; a0:Bitmapbyte,d0.b:BitmapBit = BitMapPTR(d0.w:Secnum)		?:a0/d0/d1
BitMapPTRD2:	move.l	d2,d0
BitMapPTR:	subq.w	#2,d0
		move.w	d0,d1
		and.w	#$07,d0
		lsr.w	#3,d1
		eor.w	#3,d1
		move.l	acp_BitMap(a5),a0
		lea	4(a0,d1.w),a0
		rts
; ---------------------------------------------------------
AllocKeyTab:	move.w	s_InBlocks(a5),d0
		cmp.w	s_OutBlocks(a5),d0
		bhi.s	.maxsize
		move.w	s_OutBlocks(a5),d0
.maxsize:	move.w	d0,s_TableSize(a5)
		ext.l	d0
		move.l	d0,d2
		lsr.l	#5,d0			; 1 DBptr per 32 blocks
		addq.l	#1,d0
		lsl.l	#2,d0			; need so many bytes
		lsl.l	#1,d2			; 2 bytes for each KeyAddr
		add.l	d2,d0			; alltogether
		addq.l	#7,d0
		andi.l	#$FFFFFFF8,d0
		move.l	d0,l_KeyTable(a5)
		move.l	#MEMF_PUBLIC+MEMF_CLEAR,d1 ; must be cleared !!!!!!
		CCALL_LIB Sys,AllocMem
		move.l	d0,awp_KeyTable(a5)	; BaseAdr KeyTable
		beq.s	.back			; Memory not available
		bset.b	#xALLOCATE,c_flags(a5)
		add.l	d2,d0
		move.l	d0,app_DBptr(a5)	; BaseAdr DBptr's
.back:		rts
; -----------------
; !success = Allocate()				?: a0-a2/d0-d2
Allocate:	move.l	l_Buffer(a5),d2
		move.l	app_DBptr(a5),a2
.allocloop:	moveq	#MEMF_PUBLIC,d1
		move.l	d2,d3
		move.l	d2,d0
		sub.l	#SIZE*4*32,d2
		bmi.s	.last
		move.l	#SIZE*4*32,d0
.last:		CCALL_LIB Sys,AllocMem
		move.l	d0,(a2)+
		beq.s	.back
		tst.l	d2
		bmi.s	.back
		bne.s	.allocloop
		moveq	#-1,d2
.back:		rts
; -----------------
; Deallocate()					?: a0-a2/d0-d2
Deallocate:	move.l	l_Buffer(a5),d2
		move.l	app_DBptr(a5),a2
.dealloop:	move.l	d2,d0
		sub.l	#SIZE*4*32,d2
		bmi.s	.last
		move.l	#SIZE*4*32,d0
.last:		move.l	(a2),a1
		move.l	a1,d1
		beq.s	.free2
		CCALL_LIB Sys,FreeMem
		clr.l	(a2)+
		tst.l	d2
		bmi.s	.free2
		bne.s	.dealloop
.free2:		rts
; -----------------
; success = RemBitPlane()			?: a0/a1/d0/d1
RemBitPlane:	CCALL_LIB Int,OpenWorkBench
		move.l	d0,a1
		cmp.b	#2,sc_BitMap+bm_Depth(a1)
		bne.s	.huch
		move.b	#1,sc_BitMap+bm_Depth(a1)
		move.l	sc_BitMap+bm_Planes+4(a1),a0
; the following is a FreeRaster for the second WB-Bitplane
		moveq	#0,d0
		move.w	sc_Width(a1),d0
		addi.w	#15,d0
		asr.w	#3,d0
		andi.w	#$fffe,d0
		mulu	sc_Height(a1),d0
		move.l	a0,a1
		CCALL_LIB Sys,FreeMem

		CCALL_LIB Int,RemakeDisplay
		bset.b	#xBITPLANE,c_flags(a5)
		moveq	#0,d0
.huch:		rts
; -----------------
; AddBitPlane()					?: a0-a2/d0/d1
AddBitPlane:	btst.b	#xBITPLANE,c_flags(a5)
		beq.s	.huch
		CCALL_LIB Int,OpenWorkBench
		move.l	d0,a1
		move.l	a1,a2
		cmp.b	#1,sc_BitMap+bm_Depth(a2)
		bne.s	.huch
; the following is an AllocRaster for the second WB-Bitplane
		moveq	#0,d0
		move.w	sc_Width(a2),d0
		addi.w	#15,d0			; this three commands are
		asr.w	#3,d0			; what AllocRaster does
		andi.w	#$fffe,d0		; in Kickstart 1.3
		mulu	sc_Height(a2),d0
		move.l	#MEMF_CHIP+MEMF_CLEAR,d1
		CCALL_LIB Sys,AllocMem

		beq.s	.huch
		move.l	d0,sc_BitMap+bm_Planes+4(a2)
		move.b	#2,sc_BitMap+bm_Depth(a2)

		CCALL_LIB Int,RemakeDisplay
.huch:		bclr.b	#xBITPLANE,c_flags(a5)
		rts
; -------------------------------------
; TabbingIn()						?: none
TabbingIn:	movem.l	a0/a1/d0-d3,-(a7)
		move.w	s_dirlevel(a5),d3
		ext.l	d3
		beq.s	.back
		cmp.w	#24,d3
		bls.s	.ok
		moveq	#24,d3
.ok:		lea	cS_Spaces(pc),a0
		move.l	a0,d2
		move.l	bp_StdOut(a5),d1
		CCALL_LIB Dos,Write
.back:		movem.l	(a7)+,a0/a1/d0-d3
		rts
; ---------------------------------------------
; ConvertBSTR(a1:*Buffer)				?: a0/d0
ConvertBSTR:	movem.l	a0/a1/d0-d2,-(a7)
		lea	NAME(a1),a1
		moveq	#0,d1
		move.b	(a1),d1
		cmp.b	#30,d1		; not more than 30 chars are allowed
		bls.s	.nameok
		bsr.s	CreateName
		moveq	#0,d1
		move.b	(a1),d1

.nameok:	moveq	#0,d0
		move.l	d1,d2
		lea	1(a1),a0	; NAME+1(*buffer) in a0
		lea	NameBuf(a5),a1
.loop:		subq.w	#1,d1
		bmi.s	.end
		mulu	#13,d2
		move.b	(a0)+,d0
		move.b	d0,(a1)+
		cmp.b	#'a',d0
		bcs.s	.notlower
		cmp.b	#'z',d0
		bhi.s	.notlower
		and.w	#$DF,d0			; force upper Case
.notlower:	add.l	d0,d2
		and.l	#$7ff,d2
		bra.s	.loop
.end:		clr.b	(a1)+
		divu	#72,d2
		swap	d2
		move.w	d2,s_hash(a5)
		movem.l	(a7)+,a0/a1/d0-d2
		rts
; ---------------------------
; CreateName( a1:NAME(*buffer) )		?: d1
CreateName:	movem.l	a0/d0,-(a7)
		lea	cS_Lazarus(pc),a0
		cmp.l	#1,STYPE-NAME(a1)
		beq.s	.root
		lea	cS_Dir(pc),a0
		cmp.l	#2,STYPE-NAME(a1)
		beq.s	.dir
		lea	cS_File(pc),a0
.dir:		moveq	#3,d1
.loop1:		addq.b	#1,5(a0,d1.w)
		move.b	5(a0,d1.w),d0
		cmp.b	#'9',d0
		bls.s	.root
		move.b	#'0',5(a0,d1.w)
		dbf	d1,.loop1
.root:		moveq	#9,d1
.loop2:		move.b	0(a0,d1.w),0(a1,d1.w)
		dbf	d1,.loop2
		CPRINTF <" ! Bad Name encountered -- replaced by '%s'",10>,1(a1)
		movem.l	(a7)+,a0/d0
		rts
; -------------------------------------
; Z-flag = TestInfo(a1:*BlockBuffer)			?: d0
TestInfo:	movem.l	a0/a1/d1,-(a7)
		lea	NAME(a1),a0
		move.b	(a0)+,d0
		ext.w	d0
		cmp.w	#4,d0
		bhi.s	.check
.noinfo:	movem.l	(a7)+,a0/a1/d1
		moveq	#-1,d0
		rts
.check:		lea	-5(a0,d0.w),a1		; Pointer to last 5 chars of Filename
		lea	cS_Info1,a0		; Pointer to '.info' String
		moveq	#4,d1
.loop:		move.b	0(a1,d1.w),d0
		cmp.b	0(a0,d1.w),d0		; check for LowerCase
		beq.s	.matches
		cmp.b	5(a0,d1.w),d0		; check for UpperCase
		bne.s	.noinfo
.matches:	dbf	d1,.loop
		movem.l	(a7)+,a0/a1/d1
		moveq	#0,d0
		rts

; ---------------------------------------------------------
; success = SetUpDevice(d0:Name, a4: In/Out - Table)		?: a0/a1/d0/d1
SetUpDevice:	movem.l	a2/a3/d2/d3,-(a7)
		move.w	#$4000,$dff09a			; Forbid()
		move.l	d0,a2				; *Name in a2
		move.l	sp_DosBase(a5),a1
		move.l	dl_Root(a1),a1			; get APTR *RootNode
		move.l	rn_Info(a1),d0			; get BPTR *DosInfo
		lsl.l	#2,d0
		move.l	d0,a1
		move.l	di_DevInfo(a1),d2		; get first entry

.loop:		lsl.l	#2,d2
		move.l	d2,a1
		cmp.l	#DLT_DEVICE,dl_Type(a1)		; Is it a device ?
		beq.s	.compare
.nomatch:	move.l	(a1),d2
		bne.s	.loop				; get next list entry
		move.w	#$c000,$dff09a			; Permit()
		bra.s	.baddevice

.compare:	move.l	dl_Name(a1),d0			; get BPTR
		move.l	a2,a0				; copy *Name
		bsr	BCstrcmp			; compare the strings
		bmi.s	.nomatch

		move.l	dn_Startup(a1),d0
		lsl.l	#2,d0
		move.l	d0,a1
		move.w	#$c000,$dff09a			: Permit ()
		cmp.l	#$400,d0
		bls.s	.baddevice
		move.l	(a1),l_InUnit(a4)		; fssm_Unit -> Unit#
		move.l	fssm_Device(a1),d2
		lsl.l	#2,d2
		addq.l	#1,d2				; make CSTR out of 0-terminated BSTR
		move.l	d2,acp_InDevice(a4)		; save DeviceName
		move.l	fssm_Environ(a1),d0
		lsl.l	#2,d0
		move.l	d0,a1				; *Environment in a1
		move.l	#$444f5300,d0			; old FileSystem
		cmp.w	#DE_DOSTYPE,de_TableSize+2(a1)
		bcs.s	.short
		cmp.l	de_DosType(a1),d0
		beq.s	.short
		move.b	#$01,d0				; FastFileSystem
		cmp.l	de_DosType(a1),d0
		bne.s	.baddevice
.short:		move.l	d0,l_InFS(a4)
		cmp.l	#SIZE,de_SizeBlock(a1)
		bne.s	.baddevice
		cmp.l	#2,de_Reserved(a1)
		beq.s	.stillok

.baddevice:	move.w	#$c000,$dff09a			; Permit()
		movem.l	(a7)+,a2/a3/d2/d3
		moveq	#-1,d1				; Illegal Device
		rts

.stillok:	move.w	de_BlocksPerTrack+2(a1),d2
		move.w	d2,s_InBPT(a4)
		mulu	de_Surfaces+2(a1),d2
		move.l	de_HighCyl(a1),d1
		move.l	de_LowCyl(a1),d0
		sub.l	d0,d1
		bmi.s	.baddevice
		mulu	d2,d0
		lsl.l	#8,d0
		add.l	d0,d0
		move.l	d0,l_InOffset(a4)		; set Offset for Blocks
		addq.l	#1,d1
		mulu	d1,d2
		beq.s	.baddevice
		cmp.l	#MAX_BLOCKS,d2
		bhi	TooLarge
		cmp.w	#MIN_BLOCKS,d2			; we need at least 16 blocks on Device
		bcs.s	.baddevice
		move.w	d2,s_InBlocks(a4)
		move.w	d2,s_InRoot(a4)
		lsr	s_InRoot(a4)		; ROOTBLOCK for this device
		cmp.w	#1760,d2
		bne.s	.nodisk
		moveq	#16,d1
		lea	cS_TrackDisk(pc),a1
		move.l	acp_InDevice(a4),a0
.cmploop:	cmp.b	(a0)+,(a1)+
		bne.s	.nodisk
		dbf	d1,.cmploop
		st	s_InTDflag(a4)
.nodisk:	move.l	a2,d1
		CCALL_LIB Dos,DeviceProc
		move.l	d0,sp_InProc(a4)
		beq.s	.baddevice
		bsr	OpenDevice
		bne	.baddevice
		bsr	CloseDevice

		movem.l	(a7)+,a2/a3/d2/d3
		moveq	#0,d1			; everything's just fine
		rts

; -------------------------------------------------------------
; success = BCstrcmp(d0:BSTR,a0:CSTR)	Flags: Negative= doesn't match 
BCstrcmp:	movem.l	a0/a1/d1,-(a7)
		lsl.l	#2,d0
		move.l	d0,a1				; BPTR-->APTR
		moveq	#0,d1
		move.b	(a1)+,d1			; get BSTR length in d1

.loop:		subq.w	#1,d1
		bmi.s	.cmpende
.next:		tst.b	(a0)
		beq.s	.nomatch
		cmp.b	(a0)+,(a1)+
		beq.s	.loop
		move.b	-1(a0),d0
		cmp.b	#'A',d0
		bcs.s	.nomatch
		cmp.b	#'z',d0
		bhi.s	.nomatch
		cmp.b	#'Z',d0
		bls.s	.tryother
		cmp.b	#'a',d0
		bcs.s	.nomatch

.tryother:	eor.b	#$20,d0
		cmp.b	-1(a1),d0
		beq.s	.loop
		bra.s	.nomatch

.cmpende:	cmp.b	#':',(a0)			; end of CSTR, too ?
		bne.s	.nomatch
		movem.l	(a7)+,a0/a1/d1
		moveq	#1,d0				; ... strings match
		rts

.nomatch:	movem.l	(a7)+,a0/a1/d1
		moveq	#-1,d0				; ... strings didn't match
		rts
; ---------------------  User Interaction  --------------------------
; TestBreak()						?: none
TestBreak:	movem.l	a0/d0,-(a7)
		move.l	sp_MyTask(a5),a0
		move.l	tc_SigRecvd(a0),d0
		btst.l	#SIGBREAKB_CTRL_C,d0
		bne	ControlC_Key
		movem.l	(a7)+,a0/d0
		rts
; ClearBreak()						?: a0/a1/d0/d1
ClearBreak:	moveq	#0,d0			; Clear Signal for
		move.l	#SIGBREAKF_CTRL_C,d1	; Ctrl-C key
		CCALL_LIB Sys,SetSignal
		rts
; ---------------------------
; flags = AskRetry()					?: a0/a1/d0/d1
AskRetry:	lea	cS_Empty(pc),a0
		btst.l	#MAYIGNORE,d7
		beq.s	.noign1
		lea	cS_Ignore(pc),a0
.noign1:	CPRINTF <"(33mA31m)bort / (33mR31m)etry %s?">,<a0,l>
		bsr.s	InputLine
		and.w	#$DF,d0
		cmp.b	#'R',d0
		bne.s	.noRetry
		moveq	#0,d0
.Retry:		rts				; Z-flag : Retry
.noRetry:	cmp.b	#'A',d0
		beq.s	.Abort
		btst.l	#MAYIGNORE,d7
		beq.s	AskRetry
		cmp.b	#'I',d0
		beq.s	.Ignore
		bra.s	AskRetry
.Ignore:	moveq	#1,d0			; no flag : Ignore
		rts
.Abort:		moveq	#-1,d0			; N-flag : Abort
		rts
; ---------------------------
; a0:*InLine = InputLine()				?: a0/d0/d1
InputLine:	movem.l	d2/d3/a1,-(a7)
.again:		move.l	bp_StdIn(a5),d1
		move.l	acp_CpBuf(a5),d2
		moveq	#80,d3			; we don't take more input
		bsr	TestBreak
		CCALL_LIB Dos,Read
		bsr	TestBreak
		tst.l	d0			; how many chars ?
		beq.s	.again			; no chars --> Panic !!
		bmi	Abort			; Error, how come ?
		cmp.w	#10,d0			; hey, c'mon ONE Character Only
		bhi.s	.again
		move.l	acp_CpBuf(a5),a0
.loop:		cmp.b	#' ',(a0)+		; skip leading spaces
		beq.s	.loop
		move.b	-(a0),d0
		movem.l	(a7)+,d2/d3/a1
		rts
; ---------------------------
; flags=Confirm(a0:Meldung)					?:a0/d0
Confirm:	movem.l	a1/a2/d1,-(a7)
		move.l	a0,a2
.loop:		CPRINTF <"%s (Y/N) ? ">,<a2,l>
		bsr.s	InputLine
		and.w	#$DF,d0
		cmp.b	#'Y',d0
		beq.s	.YES
		cmp.b	#'N',d0
		bne.s	.loop
.YES:		movem.l	(a7)+,a1/a2/d1
		cmp.b	#'Y',d0		; if Z=1 then YES
		rts
; ---------------------------
InsertSource:	lea	cS_Source(pc),a0
		move.l	acp_InName(a5),d0
		btst.l	#ONEDRIVE,d7
		bne.s	InsPrint
		lea	cS_Komma(pc),a1
		bra.s	InsPrint2

InsertDestin:	lea	cS_Destin(pc),a0
		move.l	acp_OutName(a5),d0

InsPrint:	lea	cS_HitReturn(pc),a1
InsPrint2:	CPRINTF <" Insert %s disk in drive 33m%s31m %s">,<a0,l>,<d0,l>,<a1,l>
		cmp.b	#',',(a1)
		beq.s	InsertDestin
		bsr	InputLine
		rts

; ---------- A0/D0:Name = GetFileName() 		?: a0/a1/d0/d1/d2
GetFileName:	move.l	acp_doscom(a5),a1	; *cmdline in a1
		moveq	#' ',d1			; delimiter in d1
		tst.w	s_dosccnt(a5)		
		beq.s	GFNnix
		bpl.s	SOcontinue
GFNnix:		SETNOTEQ
		rts

SOcontinue:	bsr.s	GFNgetchar
		beq.s	SOcontinue
		cmp.b	#LF,d0
		beq.s	GFNnix
.chkdelim:	cmp.b	#'-',d0
		beq.s	SetOptions
		cmp.b	#'"',d0
		bne.s	.first
		move.b	d0,d1			; set new delimiter
		bsr.s	GFNgetchar
.first:		lea	-1(a1),a0			; keep *FileName

.loop:		cmp.b	d1,d0
		beq.s	.delimit
		cmp.b	#LF,d0
		beq.s	.delimit2
		bsr.s	GFNgetchar
		bra.s	.loop

.delimit:	cmp.b	#' ',d0
		beq.s	.delimit2
		cmp.b	#' ',(a1)
		bne	TooFewInput		; if bad delimiter used
.delimit2:	clr.b	-1(a1)
		move.l	a1,acp_doscom(a5)
		cmp.b	#'?',(a0)
		beq	ShowUsage
		cmp.b	#':',-2(a1)
		bne	TooFewInput		; if colon missing after DeviceName
		move.l	a0,d0
		SETZERO
		rts

GFNgetchar:	move.b	(a1)+,d0
		subq.w	#1,s_dosccnt(a5)
		bmi.s	GFNnix0			; this shouldn't happen
		cmp.b	#' ',d0
		rts
GFNnix0:	move.l	(a7)+,d0
		SETNOTEQ
		rts

SetOptions:	bsr.s	GFNgetchar
		beq.s	SOcontinue
		cmp.b	#LF,d0
		beq.s	GFNnix
		ori.w	#$20,d0			; set all lowercase
		cmp.b	#'i',d0
		bne.s	.noinfo
		bsr.s	GetNum
		bmi	BadOption
		move.w	d0,l_maxleni(a5)
		bra.s	SetOptions

.noinfo:	cmp.b	#'o',d0
		bne.s	.noother
		bsr.s	GetNum
		bmi	BadOption
		move.w	d0,l_maxlena(a5)
		bra.s	SetOptions

.noother:	cmp.b	#'r',d0
		bne.s	.noreserve
		bsr.s	GetNum
		bmi	BadOption
		cmp.w	#30,d0
		bhi	BadOption
		move.w	d0,s_Reserve(a5)
		bra.s	SetOptions

.noreserve:	moveq	#optend-options-1,d2
.soloop:	cmp.b	options(pc,d2.w),d0
		bne.s	.notthis
		add.w	#VERBOOSE,d2
		bset	d2,d7
		bra.s	SetOptions
.notthis:	dbf	d2,.soloop
		bra	BadOption

options:	dc.b	'veukmntl'
optend:

; reserved		0-7	; Bits 0-7 : reserved for SETZERO macro (always cleared)
DEVOPEN		equ	8	; Bit  8 : Device is open
READING		equ	9	; Bit  9 : we're reading from Disk
INDREF		equ	10	; Bit 10 : Blocks Referenced through Indirection Table
BMVALID		equ	11	; Bit 11 : Current BitMap is Valid
SCHECKED	equ	12	; Bit 12 : Reflects if Disk structure is checked
REARRANGED	equ	13	; Bit 13 : Flags if Buffer content has been rearranged
ONEDRIVE	equ	14	; Bit 14 : Working on one drive only
; reserved		15	; Bit 15 : reserved for SETNEG macro (always set)
VERBOOSE	equ	16	; Bit 16 : Verboose Mode enable
ECONOMY		equ	17	; Bit 17 : Load just valid data
UNDELETE	equ	18	; Bit 18 : Undelete files on Source
KEEPOLD		equ	19	; Bit 19 : no Rearrangement desired
MIRROR		equ	20	; Bit 20 : Try a verbatim copy of the disks
NOVERIFY	equ	21	; Bit 21 : No Verify for Destinations != 3.5" selected
TESTONLY	equ	22	; Bit 22 : Test Dos Structure of Source only
LISTBLOCKS	equ	23	; Bit 23 : Place FileList-Blocks among Data Blocks
VERIFYING	equ	24	; Bit 24 : We're Verifying right now
PREFERRED	equ	25	; Bit 25 : File we're working on is to be narrow
SOURCETD	equ	26	; Bit 26 : Source Disk is trackdisk.device
DESTINTD	equ	27	; Bit 27 : Destination Disk is trackdisk.device
FFS		equ	28	; Bit 28 : FastFileSystem used
MAYIGNORE	equ	29	; Bit 29 : Read Errors may be ignored
IOERROR		equ	30	; Bit 30 : Bad Block encountered
; reserved		31	; Bit 31 : reserved for SETNOTEQ macro (always cleared)

; Bits in Variable c_flags(a5)
xUNDEL		equ	0	; Bit 0 : Undelete is calling TraceFile
xBITPLANE	equ	1	; Bit 1 : Bitplane was removed from Workbench screen
xPORTADDED	equ	2	; Bit 2 : our ReplyPort is public to System
xINHIBIT	equ	3	; Bit 3 : Dos Processes are Inhibited
xALLOCATE	equ	4	; Bit 4 : Allocation of Pointer area successful
xDISKIDENT	equ	5	; Bit 5 : We're rewriting the Boot-Block
xTRACKSALVE	equ	6	; Bit 6 : TrackSalve Found - Flag

GetNum:		moveq	#-1,d2
.loop1:		bsr	GFNgetchar
		beq.s	.numend
		cmp.b	#LF,d0
		beq.s	.numend
		cmp.b	#'0',d0
		bcs.s	.numend
		cmp.b	#'9',d0
		bhi.s	.numend
.ziffer:	tst.l	d2
		bpl.s	.d2init
		moveq	#0,d2
.d2init:	mulu	#10,d2
		and.w	#$0f,d0
		add.w	d0,d2
		bra.s	.loop1
.numend:	subq.l	#1,a1
		addq.w	#1,s_dosccnt(a5)
		move.l	d2,d0
		rts

; ----------------------  String - data  ---------------------------
cS_Error:	dc.b	10," ! ",0

cS_TooMany:	dc.b	"Too many Input Arguments",10,0
cS_Specify:	dc.b	"Please Specify a Source and a Destination Device",10,0
cS_DiffSize:	dc.b	"Mirror copy applies to equivalent size devices only",10,0
cS_DiskFull:	dc.b	"Buffer will not fit on Destination drive",10,0
cS_DirTooDeep:	dc.b	"Directories nested to deep",10,0
cS_ReadFail:	dc.b	"Source Devices doesn't behave",10,0
cS_BadOption:	dc.b	"Bad Option specified",10,0
cS_MemInSuffi:	dc.b	"Insufficient Memory, I'm sorry",10,0
cS_BadFormat:	dc.b	"Sorry, disk is not formatted for Source Device Filesystem",10,0
cS_OtherFS:	dc.b	"FileSystem for Source and Destination Device are incompatible",10,0
cS_BmBad:	dc.b	"Bitmap on Source invalid; Opt -e not applicable",10,0
cS_DiffFS:	dc.b	"Format on Source differs from mount specification of Source Device",10,0
cS_BadOptEx:	dc.b	"Option -"
cS_Option:	dc.b	"u and -e don't work together",10,0
cS_TooLarge:	dc.b	"More than 4064 blocks on Device",10,0

cS_StrangeVerify: dc.b	10," ! Track Data differs on Verifying",10,0
; ---------------
cS_Usage:
	dc.b	"  USAGE:  SINDICO [-tvnmlkeui#o#r#] <source> <destination>",10
	dc.b	"	( -i/-o: number of blocks 0<= # <=4064 ;  -r: fraction 0<= # <=30)",10
	dc.b	"	 -i#  max. Size of .info - Files to be preferred (16)",10
	dc.b	"	 -o#  max. Size of other Files to be preferred (3)",10
	dc.b	"	 -r#  Fraction of free blocks to be reserved for Directory (8)",10
	dc.b	"	 -e   Economy Mode : load only valid DOS blocks from Source",10
	dc.b	"	 -v   Verbose mode",10
	dc.b	"	 -n   Don't verify when TrackSalve is installed",10
	dc.b	"	 -k   Keep old structure - no rearrangement",10
	dc.b	"	 -m   Mirror copy - no check nor rearrangements made",10
	dc.b	"	 -u   Undelete enable - look for deleted files",10
	dc.b	"	 -l   Place FileList-blocks among Data blocks",10
	dc.b	"	 -t   Test Source only - no Destination needed / accepted",10,10
	dc.b	"  You can specify (almost) any Device with Old- or Fast- FileSystem",10
	dc.b	"  up to 4064 blocks ( partitions< 2Mb ) depending on your free RAM"
cS_DNewLine	dc.b	10,10,0
cS_Titel:	dc.b	" SInDiCo v1.31  [27-apr-91]  1990,91 Martin Rex  (freely distibutable)",10,10,0
cS_Abort:	dc.b " 33mUser aborted !31m",10,0
cS_CTRL_C:	dc.b	10,"^C --",0
cS_Spaces:	dc.b	"                                ",0
cS_Success:	dc.b	" Mission accomplished,  see ya !"
cS_NewLine:	dc.b	10,0
cS_FFScomment	dc.b	"FFS "
cS_Comment:	dc.b	"undeleted"
cS_Commentt:
cS_WriteProt:	dc.b	" ! Disk is write-protected : ",0
; --------------------
cS_WriteFail:	dc.b	' ! Writing Destination disk FAILED - try again',0
cS_NoRoot:	dc.b	" ! Uh-oh, your disk doesn't even contain a legal root directory",10
		dc.b	'  Do you want me to create one',0
cS_ForceDOS:	dc.b	' Do you really want to search for DOS-files on this disk',0
cS_Dangerous:	dc.b	' ! WARNING: Undelete for FastFileSystem is NOT RELIABLE, File data may',10
		dc.b	'            be messud up, I can only check for link conflicts !',10,10,0

cS_Doslibname:	dc.b	'dos.library'
cS_Empty:	dc.b	0
cS_Intlibname:	dc.b	'intuition.library',0
cS_TrackDisk:	dc.b	'trackdisk.device',0
cS_Ignore:	dc.b	'/ (33mI31m)gnore ',0

cS_Source:	dc.b	'33mSource31m     ',0
cS_Destin:	dc.b	'33mDestination31m',0
cS_RemoveFirst:	dc.b	' Remove disk(s) or DOS may get confused '
cS_HitReturn:	dc.b	'and hit RETURN ',0
cS_Komma:	dc.b	',',10,0
cS_Info1:	dc.b	'.info'
cS_Info2:	dc.b	'.INFO'
cS_Reading:	dc.b	'Reading',0
cS_Writing:	dc.b	'Writing  ',0
cS_Verifying:	dc.b	'Verifying',0
cS_Rewriting:	dc.b	'ReWriting',0
cS_Checked:	dc.b	'checked,   ',0
cS_Rearranged:	dc.b	'rearranged,',0
cS_Dir:		dc.b	8,'Dir_0000',0
cS_File:	dc.b	8,'File0000',0
cS_Lazarus:	dc.b	8,'!Lazarus',0
cS_Root:	dc.b	'Root',0
cS_Directory:	dc.b	'Directory',0
; -----------------
cS_BadChkSum:	dc.b	'bad checksum',0
cS_BadSequence:	dc.b	'bad sequence number',0
cS_BadNext:	dc.b	'bad next',0
cS_WrongOwn:	dc.b	"own key doesn't match",0
cS_FLnofirst:	dc.b	'0 expected in lword 4',0
cS_Double:	dc.b	'key already used',0
cS_BadHash:	dc.b	'bad key reference',0
cS_LinkConf:	dc.b	'FFS link conflict - DANGER !',0
cS_TSsemname:	dc.b	'TrackSalve Data Hook',0
cS_TSfound:	dc.b	'(TrackSalve found in memory; did you enable its verify ??)',10,0
		even
; ----------------------  Variablen  -------------------------------
	RSRESET
; +-+-+-+-+-+-+-+-+-+  Pointers  +-+-+-+-+-+-+-+-+-+
; ----- structure Pointer
sp_DosBase:	rs.l	1
sp_IntBase:	rs.l	1
sp_MyTask:	rs.l	1

; ----- char array Pointer
acp_CpBuf	rs.l	1
acp_doscom	rs.l	1
acp_BitMap	rs.l	1
acp_next	rs.l	1
acp_CurDir	rs.l	1
acp_lastdata	rs.l	1
acp_TBptr	rs.l	1

; ----- pointer array Pointer
app_DBptr	rs.l	1
; ----- word array Pointer
awp_KeyTable	rs.l	1

; ----- BPTRs
bp_StdOut	rs.l	1
bp_StdIn	rs.l	1

; ---------- Buffers ----------
StdPacket	rs.b	44		; just one Arg allowed
IOextTD		rs.b	IOTD_SIZE
ReplyPort	rs.b	MP_SIZE
BitMap		rs.b	SIZE*4
NameBuf		rs.b	NAMEBUF

; +-+-+-+-+-+-+-+-+-+  Values    +-+-+-+-+-+-+-+-+-+
acp_InName	rs.l	1		; char *Name of Logical DOS-Device
acp_InDevice	rs.l	1		; char *Name of Exec Device
sp_InProc	rs.l	1		; APTR Process message Port of Handler
l_InFS		rs.l	1		; FileSystem used on that Device
l_InUnit	rs.l	1		; Unit Number of the Device
l_InOffset	rs.l	1		; Offset for BlockIO on same Unit
l_InBlocks	rs.w	1		; cheat to make long Block#
s_InBlocks	rs.w	1		; Max. Block Number on this Unit
l_InRoot	rs.w	1
s_InRoot	rs.w	1		; RootBlock of Infile
s_InTDflag	rs.w	1		; flag that is set when it's a trackdisk device
s_InBPT		rs.w	1		; de_BlocksPerTrack

acp_OutName	rs.l	1
acp_OutDevice	rs.l	1
sp_OutProc	rs.l	1
l_OutFS		rs.l	1
l_OutUnit	rs.l	1
l_OutOffset	rs.l	1
l_OutBlocks	rs.w	1		; Cheating to get long Sec#
s_OutBlocks	rs.w	1
l_OutRoot	rs.w	1
s_OutRoot	rs.w	1
s_OutTDflag	rs.w	1
s_OutBPT	rs.w	1

; ----- longs
l_panic		rs.l	1
l_TFstack	rs.l	1
l_KeyTable	rs.l	1
l_Buffer	rs.l	1
l_maxleni	rs.l	1
l_maxlena	rs.l	1
l_Parent	rs.l	1
l_newheader	rs.l	1
l_keepfs	rs.l	0
l_sequence	rs.l	1
l_realkey	rs.l	1
l_seclen	rs.w	1
s_seclen	rs.w	1
l_TBlen		rs.l	1
l_maxlen	rs.l	1
l_warnings	rs.l	1

; ----- shorts
s_error		rs.w	1
s_dosccnt	rs.w	1
s_hash		rs.w	1
s_dirlevel	rs.w	1
s_htsize	rs.w	1
s_bpt		rs.w	0
s_maxdirs	rs.w	1
s_bmblock	rs.w	1
s_TableSize	rs.w	1
s_free		rs.w	1
s_removed	rs.w	1
s_undel		rs.w	1
s_uppersec	rs.w	1
s_outbl		rs.w	0
s_Reserve	rs.w	1
s_badblocks	rs.w	1

; ----- chars
c_flags		rs.w	1
; ----------
VariLen		rs.l	0
; -----------------------------------------------------------
